//main.c

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <semaphore.h>
#include <pthread.h>
#include <fcntl.h>
#include <time.h>
#include "maindat.h"
#include "wcam.h"
#include "bmp.h"
#include "main.h"
#include "maindat.h"
#include "types.h"


char 				filenameBMP[32];		//имя файла шаблонного файла BMP
int				shmCMD;
uint8_t				*addrCMD;
sem_t 				*semCNTRL;
int				shmBMP;
uint8_t				*addrBMP;
sem_t 				*semBMP;
time_t				mainTime;

int main(int argc, char* argv[])
{
	int 	scnt	= 1;
	int	res;
    	U32 	port;
	//проверка наличия параметров
	if(argc < 2) 
	{
        	printf("--- Нет параметров !!!\r\n");
		printf("--- Используйте \"--help\" для подскакзки\r\n\r\n");
        	return 1;	//нет параметров
    	}
	while(scnt < argc)
        {
                //подсказка
                if(strcmp(argv[scnt], "--help") == 0)
                {
                        printf(__help);
                        return 0;
                }
		//дата и версия
	        if(strcmp(argv[scnt], "--version") == 0)
		{
	        	printf("Дата: ");
			printf(_date);
			printf("  Весия: ");
			printf(_version);
			printf("\n");
	                return 0;
	        }
		//интерактивный тест №1
                else if(strcmp(argv[scnt], "--test1") == 0)
                {
			if(test1())
			{
				printf("Камера не обнаружена\n");
				return 2;
			}
                        return 0;
                }
		//интерактивный тест №2
                else if(strcmp(argv[scnt], "--test2") == 0)
                {
			if(test2())
			{
				printf("Камера не обнаружена\n");
				return 2;
			}
                        return 0;
                }
		//информация
                else if(strcmp(argv[scnt], "--info") == 0)
                {
			if(info())
			{
				printf("Камера не обнаружена\n");
				return 2;
			}
			sleep(1);
			printf("\n==== Камера ====\nширина:  %i\nвысота: %i\n\n", width, height);
                        return 0;
                }
		else if(strcmp(argv[scnt], "--fbmp") == 0)
		{
			scnt++;
			if(!(scnt < argc))
			{
				printf("не задано имя файла шаблонного BMP файла\n");
				return 3;
			}
			memset(&filenameBMP[0], 0, 32);
			strcpy(&filenameBMP[0], argv[scnt]);
		}
		else
		{
			printf("Параметр: \"%s\" не определён\n", argv[scnt]);
			return 4;			//неопределённый параметр
		}
		scnt++;
	}
	//
	//tmark	= 0;	//обнуление маркера времени
	//запуска модуля камеры
	if(CamStart())
	{
		printf("Not camera detect\n");
		sleep(1);
		return 2;
	}
	//
	createSHMcntrl();
	createSHMbmp();
	//
	while(1)
	{
		mainTime	= time(NULL);
		rwSHMcntrl();
		wrieteSHMbmp();
		usleep(_mainsleep);
	}
	//
	return 0;
}

int createSHMcntrl(void)
{
	//
	//память - создание
        if ( (shmCMD = shm_open(gdatSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 1;
	if ( ftruncate(shmCMD, gdatSHARED_MEMORY_OBJECT_SIZE + 1) == -1 ) 
                return 2;
	if ( (addrCMD = (uint8_t*)(mmap(0, gdatSHARED_MEMORY_OBJECT_SIZE + 1, PROT_WRITE|PROT_READ, MAP_SHARED, shmCMD, 0))) == (u_int8_t*)-1 )
                return 3;
	//семафор - создание
	if ( (semCNTRL = sem_open(gdatSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
		return 4;
	sem_post(semCNTRL);
	usleep(500000);
	sem_wait(semCNTRL);
	//
	memset(addrCMD, 0, gdatSHARED_MEMORY_OBJECT_SIZE);
	sem_post(semCNTRL);
	return 0;
}

int rwSHMcntrl(void)
{
	GDATA1	*gd;
	//
	sem_wait(semCNTRL);
	//
	gd = (GDATA1*)(addrCMD);
	gd->timeCamwork			= mainTime;
	//
	sem_post(semCNTRL);
}

//разделяемая память - формирование
int createSHMbmp(void)
{
	//определяем параметры шаблона BMP (размер)
	BMP_FileAnalise(&filenameBMP[0], &BMP_DUMP[0]);
	//память - создание
        if ( (shmBMP = shm_open(bmpSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 1;
	if ( ftruncate(shmBMP, bhfi.bfSize + 1) == -1 ) 
                return 2;
	if ( (addrBMP = (uint8_t*)(mmap(0, bhfi.bfSize + 1, PROT_WRITE|PROT_READ, MAP_SHARED, shmBMP, 0))) == (u_int8_t*)-1 )
                return 3;
	//семафор - создание
	if ( (semBMP = sem_open(bmpSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
		return 4;
	sem_post(semBMP);
	usleep(500000);
	sem_wait(semBMP);
	memcpy((uint8_t*)(addrBMP), &BMP_DUMP[0], bhfi.bfSize);
	sem_post(semBMP);

	return 0;
}

//разделяемая память - обращение
int wrieteSHMbmp(void)
{
	dataToBMP();
	sem_wait(semBMP);
	memcpy((uint8_t*)(addrBMP), &BMP_DUMP[0], bhfi.bfSize);
	sem_post(semBMP);
	return 0;
}


