//gdat.c

#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <semaphore.h>
#include <pthread.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include "gdat.h"
#include "motors.h"

pthread_mutex_t         	gdmemMutex;
pthread_t               	hgdmemnProcess;
sem_t 				*sem;
GDATA1 				*addr;
GDATA1 				gdat;
int 				shm;
uint64_t			timeSonar;


//старт доступа к разделякмой памяти
int	gdmemstart(void)
{
	//память - создание
	if ( (shm = shm_open(gdatSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
	{
        	perror("shm_open");
        	return 1;
    	}
	if ( ftruncate(shm, gdatSHARED_MEMORY_OBJECT_SIZE+1) == -1 ) 
	{
		perror("ftruncate");
		return 2;
        }
	if ( (addr = mmap(0, gdatSHARED_MEMORY_OBJECT_SIZE+1, PROT_WRITE|PROT_READ, MAP_SHARED, shm, 0)) == (GDATA1*)-1 )
	{
        	perror("mmap");
        	return 3;
    	}
	//семафор - создание
	if ( (sem = sem_open(gdatSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
	{
		perror("sem_open");
		return 4;
	}
	sem_post(sem);
	//mutex create
        if(!(pthread_mutex_init(&gdmemMutex,NULL) == 0))
                return 5;
	pthread_create(&hgdmemnProcess,NULL,(void*) gdmemProcess,NULL);
	//
	return 0;
}

//процесс доступа к разделяемой памяти
void gdmemProcess(void)
{
	while(1)
	{
		pthread_mutex_lock(&gdmemMutex);
		sem_wait(sem);
		//
		gdat.timeSonar			= addr->timeSonar;
		gdat.timeCamwork		= addr->timeCamwork;
		gdat.timeWSbot			= addr->timeWSbot;
		gdat.scntrl			= addr->scntrl;
		gdat.statSonar			= addr->statSonar;
		gdat.statCamwork		= addr->statCamwork;
		gdat.statWsbot			= addr->statWsbot;
		gdat.sonardistance		= addr->sonardistance;
		//
		switch(gdat.scntrl)
		{
			case _scntrl_servoANDmotors:	//управление от приводов - выключение движения, но разрешение разворота на месте
				//разрешение по малой дистанции и по развороту				
				if((gdat.sonardistance < _distance_min_lim) &&
				(((addr->wrmotors[0] + addr->wrmotors[1]) == 0) && (addr->wrspeed_motors[0] == addr->wrspeed_motors[1])))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
					addr->scntrl			= _scntrl_free;
				}
				//разрешение по большой дистанции и горизонтальному нулевому положению сенсоров
				else if((gdat.sonardistance >= _distance_min_lim) &&
				(gdat.rdservo[0] == 0))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
					addr->scntrl			= _scntrl_free;
				}
				else if(((addr->wrmotors[0] + addr->wrmotors[1]) == 0) && (addr->wrspeed_motors[0] == addr->wrspeed_motors[1]))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
					addr->scntrl			= _scntrl_free;
				}
				else	//ограничение
				{
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
					gdat.wrmotors[0]		= 0;
					gdat.wrmotors[1]		= 0;
					gdat.wrspeed_motors[0]		= 0;
					gdat.wrspeed_motors[1]		= 0;
					addr->wrmotors[0]		= 0;
					addr->wrmotors[1]		= 0;
					addr->wrspeed_motors[0]		= 0;
					addr->wrspeed_motors[1]		= 0;
					addr->scntrl			= _scntrl_servoANDmotors;
				}
				break;
			case _scntrl_wsbot:	//управление от wsbot
				//разрешение по малой дистанции и по развороту				
				if((gdat.sonardistance < _distance_min_lim) &&
				(((addr->wrmotors[0] + addr->wrmotors[1]) == 0) && (addr->wrspeed_motors[0] == addr->wrspeed_motors[1])))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
				}
				//разрешение по большой дистанции и горизонтальному нулевому положению сенсоров
				else if((!(gdat.sonardistance < _distance_min_lim)) &&
				(gdat.rdservo[0] == 0))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
				}
				else if(((addr->wrmotors[0] + addr->wrmotors[1]) == 0) && (addr->wrspeed_motors[0] == addr->wrspeed_motors[1]))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
				}
				else	//запрет
				{
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
					gdat.wrmotors[0]		= 0;
					gdat.wrmotors[1]		= 0;
					gdat.wrspeed_motors[0]		= 0;
					gdat.wrspeed_motors[1]		= 0;
					addr->wrmotors[0]		= 0;
					addr->wrmotors[1]		= 0;
					addr->wrspeed_motors[0]		= 0;
					addr->wrspeed_motors[1]		= 0;
					addr->scntrl			= _scntrl_servoANDmotors;
				}
				break;
			case _scntrl_sonar:
				//разрешение по малой дистанции и по развороту				
				if((gdat.sonardistance < _distance_min_lim) &&
				(((addr->wrmotors[0] + addr->wrmotors[1]) == 0) && (addr->wrspeed_motors[0] == addr->wrspeed_motors[1])))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
				}
				//разрешение по большой дистанции и горизонтальному нулевому положению сенсоров - норма
				else if((!(gdat.sonardistance < _distance_min_lim)) &&
				(gdat.rdservo[0] == 0))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
				}
				else if(((addr->wrmotors[0] + addr->wrmotors[1]) == 0) && (addr->wrspeed_motors[0] == addr->wrspeed_motors[1]))
				{
					gdat.wrmotors[0]		= addr->wrmotors[0];
					gdat.wrmotors[1]		= addr->wrmotors[1];
					gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
					gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
				}
				else	//запрет
				{
					gdat.wrservo[_MwrservoH]	= addr->wrservo[_MwrservoH];
					gdat.wrservo_speed[_MwrservoH]	= addr->wrservo_speed[_MwrservoH];
					gdat.wrservo[_MwrservoV]	= addr->wrservo[_MwrservoV];
					gdat.wrservo_speed[_MwrservoV]	= addr->wrservo_speed[_MwrservoV];
					gdat.wrmotors[0]		= 0;
					gdat.wrmotors[1]		= 0;
					gdat.wrspeed_motors[0]		= 0;
					gdat.wrspeed_motors[1]		= 0;
					addr->wrmotors[0]		= 0;
					addr->wrmotors[1]		= 0;
					addr->wrspeed_motors[0]		= 0;
					addr->wrspeed_motors[1]		= 0;
					addr->scntrl			= _scntrl_servoANDmotors;
				}
				break;
				
			default:
				break;
		}
		//
		addr->timeMotorANDservo		= gdat.timeMotorANDservo;
		addr->rdmotors[0]		= gdat.rdmotors[0];
		addr->rdmotors[1]		= gdat.rdmotors[1];
		addr->rdservo[0]		= gdat.rdservo[0];
		addr->rdservo[1]		= gdat.rdservo[1];
		addr->statServoANDmotor		= gdat.statServoANDmotor;
		//printf("addr->scntrl %02X   gdat.scntrl %02X\n", addr->scntrl, gdat.scntrl);
		//
		sem_post(sem);
		pthread_mutex_unlock(&gdmemMutex);
		usleep(_gmemSleep);
	}
	pthread_exit(0);
}



