//main.c

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include "main.h"
#include "motors.h"
#include "maindat.h"
#include "gdat.h"





int main(int argc, char* argv[])
{
	int	res;
	//GDATA1	cntrl;
	int 	scnt	= 1;
	char	serialname[255] = {"/dev/ttyUSB0"};
	int 	baudrate	= 9600;
	wait_dev		= 75000;
	//проверка наличия параметров
	if(argc < 2) 
	{
        	printf("--- Нет параметров !!!\r\n");
		printf("--- Используйте \"--help\" для подсказки\r\n\r\n");
        	return _retNOPARAM;	//нет параметров
    	}
	while(scnt < argc)
        {
                //подсказка
                if(strcmp(argv[scnt], "--help") == 0)
                {
                        printf(_help);
                        return _retOK;
                }
		//дата и версия
                if(strcmp(argv[scnt], "--version") == 0)
                {
                        printf("Дата: ");
			printf(_date);
			printf("  Весия: ");
			printf(_version);
			printf("\n");
                        return _retOK;
                }
		else if(strcmp(argv[scnt], "--test") == 0)
		{
			ctest(&serialname[0], baudrate, wait_dev);
			return 0;
		}
		else if(strcmp(argv[scnt], "--onetest") == 0)
		{
			onetest(&serialname[0], baudrate, wait_dev);
			return 0;
		}
		else if(strcmp(argv[scnt], "--movetest") == 0)
		{
			movetest(&serialname[0], baudrate, wait_dev);
			return 0;
		}
		else if(strcmp(argv[scnt], "--start") == 0)
		{
			break;
		}
		else
		{
			printf("Параметр: %s не определён!!!\n", argv[scnt]);
			return _retUNKNOWN;			//неопределённый параметр
		}
		scnt++;
	}
	//
	res = gdmemstart();
	if(res != 0)
		return res;
	res = startwork(&serialname[0], baudrate, wait_dev);
	if(res != 0)
		return res;
	//
	while(1)
	{
		usleep(_main_sleep);
	}
	//
	return _retOK;
}



