//motors.cpp
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>
#include <time.h>
#include "motors.h"
#include "maindat.h"
#include "config.h"
#include "mrtu.h"
#include "gdat.h"


int 		wait_dev;
MOTORS		motors;
//
MOVECTRL	wrmovectl;
MOVECTRL	rdmovectl;
uint64_t	timeMotorANDservo;
//uint16_t	status1;				//первый регистр флагов
uint8_t		scntrl;					//источник управления
//
pthread_mutex_t         	motorsMutex;
pthread_t               	hmotorsProcess;
//
int	res3;
int	res16;

//тест приводов
int	ctest(char * serial, int baudrate, int symwait)
{
	int	res;
	int	num_work = 0;
	//инициализация
	//memset(&motors.motors[0], 0, sizeof(MOTORS::motors[_motors_cnt]));
	//memset(&motors.servos[0], 0, sizeof(MOTORS::servos[_servos_cnt]));
	memset(&motors, 0, sizeof(MOTORS));
	//соединяемся с Arduino
	res = MRTU_Connect(serial, baudrate, symwait);
	if(res != 0)
	{
		printf("Ошибка соединения с Arduino\n");
		return 5;
	}
	//
	while(1)
	{
		num_work = mcontrol(num_work);
		if(num_work == 0)
		{
			printf("M1:%i M2:%i M3:%i M4:%i S1:%i S2:%i T:%i\n",
				motors.rmotors[0], motors.rmotors[1], motors.rmotors[2], motors.rmotors[3],
				motors.rservos[0], motors.rservos[1],
				motors.tloop);
			printf("CMD: ");
			//char c = cvWaitKey(33);
			char c = getchar();
    			if (c == 27)	// нажата ESC
        			break;
			else if(c == 0x31)
			{
				motors.motors[0] += 10;
				motors.motors[1] += 10;
				motors.motors[2] += 10;
				motors.motors[3] += 10;
			}
			else if(c == 0x32)
			{
				motors.motors[0] -= 10;
				motors.motors[1] -= 10;
				motors.motors[2] -= 10;
				motors.motors[3] -= 10;
			}
			else if(c == 0x33)
				motors.servos[0] += 10;
			else if(c == 0x34)
				motors.servos[0] -= 10;
			else if(c == 0x35)
				motors.servos[1] += 10;
			else if(c == 0x36)
				motors.servos[1] -= 10;
			else if(c == 0x30)
			{
				motors.motors[0] = 0;
				motors.motors[1] = 0;
				motors.motors[2] = 0;
				motors.motors[3] = 0;
				motors.servos[0] = 0;
				motors.servos[1] = 0;
			}
			printf("\n");
		}
		usleep(wait_dev);
	}
	//
	MRTU_Disconnect();
	return 0;
}

//одиночный тест приводов
int	onetest(char * serial, int baudrate, int symwait)
{
	int	res;
	int	num_work = 0;
	char	mc;
	char	c;
	memset(&motors, 0, sizeof(MOTORS));
	res = MRTU_Connect(serial, baudrate, symwait);
	if(res != 0)
		return res;
m0:	printf(">>> одиночный тест приводов <<<\n");
	printf("1 - тест (ComMotion) M1\n");
	printf("2 - тест (ComMotion) M2\n");
	printf("3 - тест (ComMotion) M3\n");
	printf("4 - тест (ComMotion) M4\n");
	printf("5 - тест (Multiservo) PWM0\n");
	printf("6 - тест (Multiservo) PWM1\n");
	printf("9 - выход\n");
	printf("CMD:");
	mc = getchar();
	getchar();
	printf("%i\n", mc);
	while(1)
	{
		num_work = mcontrol(num_work);
		if(num_work == 0)
		{
			printf("--- управление (1 - больше/влево/вверх, 2 - меньше/вправо/низ, 0 - останов/исходное, 9 - выход) ----\n"); 
			switch(mc)
			{
				case 0x31:
					if(c == 0x31)
						motors.motors[0] += 10;
					else if(c == 0x32)
						motors.motors[0] -= 10;
					else if(c == 0x30)
						motors.motors[0] = 0;
					else if(c == 0x39)
						goto m0;
					printf("ComMotion M1:%i\n", motors.motors[0]);
					break;
				case 0x32:
					if(c == 0x31)
						motors.motors[1] += 10;
					else if(c == 0x32)
						motors.motors[1] -= 10;
					else if(c == 0x30)
						motors.motors[1] = 0;
					else if(c == 0x39)
						goto m0;
					printf("ComMotion M2:%i\n", motors.motors[1]);
					break;
				case 0x33:
					if(c == 0x31)
						motors.motors[2] += 10;
					else if(c == 0x32)
						motors.motors[2] -= 10;
					else if(c == 0x30)
						motors.motors[2] = 0;
					else if(c == 0x39)
						goto m0;
					printf("ComMotion M3:%i\n", motors.motors[2]);
					break;
				case 0x34:
					if(c == 0x31)
						motors.motors[3] += 10;
					else if(c == 0x32)
						motors.motors[3] -= 10;
					else if(c == 0x30)
						motors.motors[3] = 0;
					else if(c == 0x39)
						goto m0;
					printf("ComMotion M4:%i\n", motors.motors[3]);
				case 0x35:
					if(c == 0x31)
						motors.servos[0] += 10;
					else if(c == 0x32)
						motors.servos[0] -= 10;
					else if(c == 0x30)
						motors.servos[0] = 0;
					else if(c == 0x39)
						goto m0;
					printf("Multiservo PWM0:%i\n", motors.servos[0]);
					break;
				case 0x36:
					if(c == 0x31)
						motors.servos[1] += 10;
					else if(c == 0x32)
						motors.servos[1] -= 10;
					else if(c == 0x30)
						motors.servos[1] = 0;
					else if(c == 0x39)
						goto m0;
					printf("Multiservo PWM1:%i\n", motors.servos[1]);
					break;
				case 0x39:
					goto m1;
				default:
					goto m0;
			}
			printf("CMD:");
			c = getchar();
			getchar();
			printf("%i\n", c);
		}
	}
	//
m1:	MRTU_Disconnect();
	return 0;
}


//управление приводами
int	mcontrol(int num_work)
{
	switch(num_work)
	{
		case 0:	//задание для 4-х моторов
			MRTU_CMD_16(1, _num_vol_m1, (u_int16_t*)(&motors.motors[0]), 4);
			num_work++;
			break;
		case 1:	//чтение значения 4-х моторов
			MRTU_CMD_3(1, _num_vol_m1, (u_int16_t*)(&motors.rmotors[0]), 4);
			num_work++;
			break;
		case 2:	//управление положением камеры - два сервопривода
			MRTU_CMD_16(1, _num_pos_s1, (u_int16_t*)(&motors.servos[0]), 2);
			num_work++;
			break;
		case 3:	//чтение положения камеры - два сервопривода
			MRTU_CMD_3(1, _num_pos_s1, (u_int16_t*)(&motors.rservos[0]), 2);
			num_work++;
			break;
		case 4: //время цикла
			MRTU_CMD_3(1, 2, (u_int16_t*)(&motors.tloop), 1);
			num_work = 0;
			break;
		default:
			num_work = 0;
			break;
	}
	return num_work;
}

//
int	movetest(char * serial, int baudrate, int symwait)
{
	int	cnt = 0;
	int 	res;
	char	str[16];
	res = MRTU_Connect(serial, baudrate, symwait);
	if(res != 0)
		return res;
	while(1)
	{
		if(cnt == 0)
		{
			printf("Скорость и направление(знак) левых приводов(-255...255):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.motors[0] = (int16_t)(atoi(str));
			printf("Время разгона/торможения левых приводов(0...65535):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.speed_motors[0] = (uint16_t)(atoi(str));
			printf("Скорость и направление(знак) правых приводов(-255...255):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.motors[1] = (int16_t)(atoi(str));
			printf("Время разгона/торможения правых приводов(0...65535):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.speed_motors[1] = (uint16_t)(atoi(str));
			printf("Позиция по горизонтали сервомашины1(влево 45...вправо -45):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.servo[0] = (int16_t)(atoi(str));
			printf("Время позиционирования по горизонтали сервомашины1(0...65535):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.servo_speed[0] = (uint16_t)(atoi(str));
			printf("Позиция по вертикали сервомашины2(вниз -30...вверх 30):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.servo[1] = (int16_t)(atoi(str));
			printf("Время позиционирования по вертикали сервомашины2(0...65535):");
			memset(&str[0], 0, 16);
			fgets(str, 16, stdin);
			wrmovectl.servo_speed[1] = (uint16_t)(atoi(str));
		}
		cnt = movecntrl(cnt, 1);
		usleep(50000);
	}
	MRTU_Disconnect();
	return 0;	
}

//управление перемещением
int	movecntrl(int numwork, uint8_t fp)
{
	switch(numwork)
	{
		case 0:	//задание параметров	
			res16 = MRTU_CMD_16(1, _MoveControl, (u_int16_t*)(&wrmovectl), 8);
			if(fp > 0)
			{
				printf("send res:%i\n", res16);
				printf("send %05i %05i %05i %05i %05i %05i %05i %05i\n",
				wrmovectl.motors[0], wrmovectl.motors[1],
				wrmovectl.speed_motors[0], wrmovectl.speed_motors[1],
				wrmovectl.servo[0], wrmovectl.servo[1],
				wrmovectl.servo_speed[0], wrmovectl.servo_speed[1]);
			}
			numwork++;
			break;
		case 1:	//чтение параметров
			res3 = MRTU_CMD_3(1, _MoveControl, (u_int16_t*)(&rdmovectl), 8);
			if(fp > 0)
			{
				printf("recv res:%i\n", res3);
				printf("recv %05i %05i %05i %05i %05i %05i %05i %05i\n",
				rdmovectl.motors[0], rdmovectl.motors[1],
				rdmovectl.speed_motors[0], rdmovectl.speed_motors[1],
				rdmovectl.servo[0], rdmovectl.servo[1],
				rdmovectl.servo_speed[0], rdmovectl.servo_speed[1]);
			}
			numwork = 0;
			break;
		default:
			numwork = 0;
			break;
	}
	return numwork;
}

//запуск рабочего потока
int	startwork(char * serial, int baudrate, int symwait)
{
	int res;
	res = MRTU_Connect(serial, baudrate, symwait);
	if(res != 0)
		return res;
	//mutex create
        if(!(pthread_mutex_init(&motorsMutex,NULL) == 0))
                return 4;
	pthread_create(&hmotorsProcess,NULL,(void*) motorsProcess,NULL);
	return 0;
}

//рабочий поток
void	motorsProcess(void)
{
	int	cntcntrl = 0;
	memset(&wrmovectl, 0, sizeof(MOVECTRL));
	memset(&rdmovectl, 0, sizeof(MOVECTRL));
	while(1)
	{
		timeMotorANDservo	= time(NULL);
		pthread_mutex_lock(&motorsMutex);
		motorsCntrl();
		cntcntrl = movecntrl(cntcntrl,0);
		pthread_mutex_unlock(&motorsMutex);
		usleep(_wmotorsSleep);
	}
	pthread_exit(0);
}

//обмен состояниеми и параметрами
void	motorsCntrl(void)
{
	pthread_mutex_lock(&gdmemMutex);
	//фиксация задания для сервомашин без ограничений в управлении
	wrmovectl.servo[0] 		= gdat.wrservo[0];		//задания положения сервомашин
	wrmovectl.servo[1] 		= gdat.wrservo[1];		//
	wrmovectl.servo_speed[0] 	= gdat.wrservo_speed[0];	//задания скорости положения
	wrmovectl.servo_speed[1] 	= gdat.wrservo_speed[1];	//
	//status1				= gdat.status1;			//
	//
	wrmovectl.motors[0] 		= gdat.wrmotors[0];		//задания моторов
	wrmovectl.motors[1] 		= gdat.wrmotors[1];		//
	wrmovectl.speed_motors[0]	= gdat.wrspeed_motors[0];	//задание скорости моторов
	wrmovectl.speed_motors[1]	= gdat.wrspeed_motors[1];	//
	//отдаём состояния
	gdat.timeMotorANDservo		= timeMotorANDservo;
	gdat.rdmotors[0]		= rdmovectl.motors[0];
	gdat.rdmotors[1]		= rdmovectl.motors[1];
	gdat.rdservo[0]			= rdmovectl.servo[0];
	gdat.rdservo[1]			= rdmovectl.servo[1];
	//параметры времени
	if(timeMotorANDservo > (gdat.timeSonar + _timeDelta))
		gdat.statServoANDmotor	&= (~(_statServoANDmotor_timeSonar));
	else
		gdat.statServoANDmotor	|= _statServoANDmotor_timeSonar;
	if(timeMotorANDservo > (gdat.timeCamwork + _timeDelta))
		gdat.statServoANDmotor	&= (~(_statServoANDmotor_timeCamwork));
	else
		gdat.statServoANDmotor	|= _statServoANDmotor_timeCamwork;
	if(timeMotorANDservo > (gdat.timeWSbot + _timeDelta))
		gdat.statServoANDmotor	&= (~(_statServoANDmotor_timeWsbot));
	else
		gdat.statServoANDmotor	|= _statServoANDmotor_timeWsbot;
	//параметры связи
	if(res3 == 0)
		gdat.statServoANDmotor	|= _statServoANDmotor_MB03conn;
	else
		gdat.statServoANDmotor	&= (~(_statServoANDmotor_MB03conn));
	if(res16 == 0)
		gdat.statServoANDmotor	|= _statServoANDmotor_MB10conn;
	else
		gdat.statServoANDmotor	&= (~(_statServoANDmotor_MB10conn));
	pthread_mutex_unlock(&gdmemMutex);
}
