//motors.h

/*
	05.10.2018
*/

#ifndef _motors_h_
#define _motors_h_
#include <sys/types.h>
#include <stdint.h>
#include "config.h"

#define _distance_min_lim	35	//ограничение по дистанции

#define	_wmotorsSleep		10000

/*
************************
* определения для      *
* моторов и сервомашин *
************************
*/
//условный маркер веремни
#define _time_mark	0x10
//режим управления
//#define _mode_contrl	0x20	//режим управления
//#define _mode_ctrl0     0       //управление прямое
//#define _mode_ctrl1     1       //управление приближением
//рабочие определения
#define _num_vol_m1	0x30	//номер регистра привода 1
#define _num_vol_m2	0x31	//номер регистра привода 2
#define _num_vol_m3	0x32	//номер регистра привода 3
#define _num_vol_m4	0x33	//номер регистра привода 4
#define _num_pos_s1	0x40	//номер регистра позиции севомашины 1
#define _num_pos_s2	0x41	//номер регистра позиции севомашины 2
#define _num_pos_s3	0x42	//номер регистра позиции севомашины 3
#define _num_pos_s4	0x43	//номер регистра позиции севомашины 4
#define _num_pos_s5	0x44	//номер регистра позиции севомашины 5
#define _num_pos_s6	0x45	//номер регистра позиции севомашины 6
#define _num_pos_s7	0x46	//номер регистра позиции севомашины 7
#define _num_pos_s8	0x47	//номер регистра позиции севомашины 8
#define _num_pos_s9	0x48	//номер регистра позиции севомашины 9
#define _num_pos_s10	0x49	//номер регистра позиции севомашины 10
#define _num_pos_s11	0x4A	//номер регистра позиции севомашины 11
#define _num_pos_s12	0x4B	//номер регистра позиции севомашины 12
#define _num_pos_s13	0x4C	//номер регистра позиции севомашины 13
#define _num_pos_s14	0x4D	//номер регистра позиции севомашины 14
#define _num_pos_s15	0x4E	//номер регистра позиции севомашины 15
#define _num_pos_s16	0x4F	//номер регистра позиции севомашины 16
#define _num_pos_s17	0x50	//номер регистра позиции севомашины 17
#define _num_pos_s18	0x51	//номер регистра позиции севомашины 18
//прочитанные определения
#define _rnum_vol_m1    0x60	//номер регистра привода 1
#define _rnum_vol_m2    0x61	//номер регистра привода 2
#define _rnum_vol_m3    0x62	//номер регистра привода 3
#define _rnum_vol_m4    0x63	//номер регистра привода 4
#define _rnum_pos_s1    0x70	//номер регистра позиции севомашины 1
#define _rnum_pos_s2    0x71	//номер регистра позиции севомашины 2
#define _rnum_pos_s3    0x72	//номер регистра позиции севомашины 3
#define _rnum_pos_s4    0x73	//номер регистра позиции севомашины 4
#define _rnum_pos_s5    0x74	//номер регистра позиции севомашины 5
#define _rnum_pos_s6    0x75	//номер регистра позиции севомашины 6
#define _rnum_pos_s7    0x76	//номер регистра позиции севомашины 7
#define _rnum_pos_s8    0x77	//номер регистра позиции севомашины 8
#define _rnum_pos_s9    0x78	//номер регистра позиции севомашины 9
#define _rnum_pos_s10	0x79	//номер регистра позиции севомашины 10
#define _rnum_pos_s11	0x7A	//номер регистра позиции севомашины 11
#define _rnum_pos_s12	0x7B	//номер регистра позиции севомашины 12
#define _rnum_pos_s13	0x7C	//номер регистра позиции севомашины 13
#define _rnum_pos_s14	0x7D	//номер регистра позиции севомашины 14
#define _rnum_pos_s15	0x7E	//номер регистра позиции севомашины 15
#define _rnum_pos_s16	0x7F	//номер регистра позиции севомашины 16
#define _rnum_pos_s17	0x80	//номер регистра позиции севомашины 17
#define _rnum_pos_s18	0x81	//номер регистра позиции севомашины 18
//
#define _MoveControl	0x90	//начало данных управления
//
#define _res_modbus	0xF0	//результат обращения по Modbus - последний код ошибки

//переменные для приводов
typedef struct _MOTORS
{
	int16_t		motors[_motors_cnt];		//задания для моторов
	int16_t		rmotors[_motors_cnt];		//прочитанные значения моторов
	int16_t		servos[_servos_cnt];		//задания для серврмашин
	int16_t		rservos[_servos_cnt];		//прочитанные значения сервомашин
	uint16_t	tloop;				//маркер времени шилда
} MOTORS;

//переменные управления
#define	_cnt_motmove	2	//правые и левые моторы
#define _Lmotmove	0	//левая пара моторов
#define _Rmotmove	1	//правая пара моторов
#define _cnt_servomove	2	//горизонтальная и вертикальная сервомашины
#define _Hservomove	0	//горизонтальная сервомашина
#define _Vservomove	1	//вертикальная сервомашина
typedef struct _MOVECTRL
{
	int16_t		motors[_cnt_motmove];
	uint16_t	speed_motors[_cnt_motmove];
	int16_t		servo[_cnt_servomove];
	uint16_t	servo_speed[_cnt_servomove];
} MOVECTRL; 

//ожидание для устройства
extern int 	wait_dev;
//тест приводов
extern int	ctest(char * serial, int baudrate, int wait_dev);
//одиночный тест приводов
extern int	onetest(char * serial, int baudrate, int symwait);
//управление приводами
int	mcontrol(int num_work);
//
extern int	movetest(char * serial, int baudrate, int symwait);
//управление перемещением
int	movecntrl(int numwork, uint8_t fp);
//рабочий поток
void	motorsProcess(void);
//запуск рабочего потока
extern int	startwork(char * serial, int baudrate, int symwait);
//обмен состояниеми и параметрами
void	motorsCntrl(void);
//
extern pthread_mutex_t  motorsMutex;
extern uint16_t		status1;				//первый регистр флагов
extern uint8_t		scntrl;					//источник управления
extern MOVECTRL		wrmovectl;
extern MOVECTRL		rdmovectl;


#endif

