//i2c.c

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <linux/i2c-dev.h>
#include <fcntl.h>
#include <string.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <time.h>
//
#include "i2c.h"


//
//открытие шины I2C
int	i2c_OPN(u_int8_t addr)
{
	int i2cHnd = open(_i2cBus, O_RDWR);
	ioctl(i2cHnd, I2C_SLAVE, addr);
	if(i2cHnd < 0)
		return -1;
	return i2cHnd;
}
//запись в шину I2C
int	i2c_WR(int i2cHnd, u_int8_t * bdata, u_int8_t bsize)
{
	int	res;
	res = write(i2cHnd, bdata, bsize);
	//printf("----i2cWR=%i\n", res);
	return res;
}

//чтение из шины I2C
int	i2c_RD(int i2cHnd, u_int8_t * bdata, u_int8_t bsize)
{
	int		res;
	res = read(i2cHnd, bdata, bsize);
	//printf("----i2cRD=%i\n", res);
	return res;
}

//закрытие устройства I2C
void	i2c_CLS(int i2cHnd)
{
	close(i2cHnd);
}

//открытие устройства I2C
int	i2c_OPEN(u_int8_t address)
{
	int i2cHandle;
	i2cHandle = i2c_OPN(address);
	if(i2cHandle < 0)
	{
		#if(_dbg > 0)
			printf("------ ERROR OPEN handle : %i\n", i2cHandle);
		#endif
		return -1;
	}
	return i2cHandle;
}

//запись в устройство I2C
int	i2c_WRIETE(int i2cHandle, u_int8_t baddr, u_int8_t * bdata, u_int8_t bsize)
{
	int	res;
	u_int8_t	i2c_txBuffer[i2cBUFFER_LENGTH];
	//memset(&i2c_txBuffer[0], 0, i2cBUFFER_LENGTH);
	i2c_txBuffer[0]	= baddr & _i2c_WR;
	memcpy(&i2c_txBuffer[1], bdata, bsize);
	res = i2c_WR(i2cHandle, &i2c_txBuffer[0], bsize + 1);
	if(res < 0)
	{
		#if(_dbg > 0)
			printf("------error SEND sz: %i\n",res);
		#endif
		return -1;
	}
	#if(_dbg > 0)
		printf("------ SEND sz: %i\n",res);
	#endif
	return res;
}

//чтение устройства I2C
int	i2c_READ(int i2cHandle, u_int8_t baddr, u_int8_t * bdata, u_int8_t bsize)
{
	int		res;
	u_int8_t	i2c_rxBuffer[i2cBUFFER_LENGTH];
	u_int8_t	sbaddr	= baddr | _i2c_RD;
	res = i2c_WR(i2cHandle, &sbaddr, 1);
	if(res < 0)
	{
		#if(_dbg > 0)
			printf("------error RD: %i\n",res);
		#endif
		return -1;
	}
	//memset(&i2c_rxBuffer[0], 0, i2cBUFFER_LENGTH);
	res = i2c_RD(i2cHandle, &i2c_rxBuffer[0], bsize);
	if(res < 0)
	{
		#if(_dbg > 0)
			printf("------error RECEIVE: %i\n",res);
		#endif
		return -2;
	}
	#if(_dbg > 0)
		printf("------RECEIVE: %i\n",res);
	#endif
	memcpy(bdata, &i2c_rxBuffer[0], bsize);
	return 0;
}

//закрытие устройства I2C
int	i2c_CLOSE(i2cHandle)
{
	i2c_CLS(i2cHandle);
	//
	return 0;
}
