//main.c


#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <semaphore.h>
#include <time.h>
#include "maindat.h"
#include "mb12xx.h"
#include "main.h"

#define _slave_addr	0x70//112
//#define _slave_addr	0xE0//224

sem_t 				*sem;
GDATA1 				*addr;
int 				shm;
uint64_t			timeSonar;
//
SENS_RADIUS			radius;
int16_t				dist;
SCNTRL				scntrl;
//
int main(int argc, char* argv[])
{
	//
	char		gd;
	int 		scnt	= 1;
	char		dbg	= 1;
	char		fshm	= 0;					
	//
	if(argc < 2)
	{
		printf("MB1242 - Testing... (use \"--help\" for info in new starting)\n");
		printf("Input mode for 5V:\n");
		printf("1 = diagremm A\n");
		printf("2 = diagremm B\n");
		printf("3 = diagremm C\n");
		printf("4 = diagremm D\n");
		printf("?");
		gd = getchar();
		switch(gd)
		{
			case '1':
				radius.type_diagramm = _type_diagramm_MB1242_A50;
				break;
			case '2':
				radius.type_diagramm = _type_diagramm_MB1242_B50;
				break;
			case '3':
				radius.type_diagramm = _type_diagramm_MB1242_C50;
				break;
			case '4':
				radius.type_diagramm = _type_diagramm_MB1242_D50;
				break;
			default:
				radius.type_diagramm = _type_diagramm_MB1242_D50;
				break;
		}
	}
	else
	{
		while(scnt < argc)
		{
			if(strcmp(argv[scnt], "--help") == 0)
			{
				printf(_help_);
				return 0;
			}
			//дата и версия
	                if(strcmp(argv[scnt], "--version") == 0)
			{
	                        printf("Дата: ");
				printf(_date);
				printf("  Весия: ");
				printf(_version);
				printf("\n");
	                        return 0;
	                }
			if(strcmp(argv[scnt], "--start") == 0)
			{
				scnt++;
				if(scnt > argc)
					radius.type_diagramm = _type_diagramm_MB1242_D50;
				else
				{
					if(strcmp(argv[scnt], "MB1242_A50"))
						radius.type_diagramm = _type_diagramm_MB1242_A50;
					else if(strcmp(argv[scnt], "MB1242_B50"))
						radius.type_diagramm = _type_diagramm_MB1242_B50;
					else if(strcmp(argv[scnt], "MB1242_C50"))
						radius.type_diagramm = _type_diagramm_MB1242_C50;
					else if(strcmp(argv[scnt], "MB1242_D50"))
						radius.type_diagramm = _type_diagramm_MB1242_D50;
					else
						radius.type_diagramm = _type_diagramm_MB1242_D50;
				}
				dbg 	= 0;
				fshm	= 1;
				break;
			}
			else
			{
				printf("parametr: \"%s\" - unknown!\n", argv[argc]);
				return 1;
			}
			scnt++;
		}
	}
	//
	if(fshm > 0)
	{
		//память - создание
		if ( (shm = shm_open(gdatSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
		{
       			perror("shm_open");
	        	return 1;
    		}
		if ( ftruncate(shm, gdatSHARED_MEMORY_OBJECT_SIZE+1) == -1 ) 
		{
			perror("ftruncate");
			return 2;
	        }
		if ( (addr = mmap(0, gdatSHARED_MEMORY_OBJECT_SIZE+1, PROT_WRITE|PROT_READ, MAP_SHARED, shm, 0)) == (GDATA1*)-1 )
		{
        		perror("mmap");
        		return 3;
    		}
		//семафор - создание
		if ( (sem = sem_open(gdatSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
		{
			perror("sem_open");
			return 4;
		}
		sem_post(sem);
	}
	//mb1242open_sensor(_slave_addr);
	scntrl.maincntrl = _maincntrl_scanmapH;
	scntrl.timeSonarOld	= time(NULL);
	//
	while(1)
	{
		timeSonar		= time(NULL);
		scntrl.timeSonar	= timeSonar;
		dist		= mb1242read_sensorR(_slave_addr, &radius);
		if(dbg > 0)
				printf("-- diagramm %i   distance %i radius %i ------ \"Cnrl+c\" for exit \n", radius.type_diagramm, dist, radius.radius);
		//
		if(fshm > 0)
		{
			sem_wait(sem);
			scntrl.timeMotorANDservo	= addr->timeMotorANDservo;
			scntrl.timeCamwork		= addr->timeCamwork;
			scntrl.timeWSbot		= addr->timeWSbot;
			scntrl.rposH			= addr->rdservo[0];
			switch (addr->scntrl)	//источник управления
			{
				case _scntrl_free:	//нет источника управления
				case _scntrl_wsbot:	//источник wsbot через веб интерфейс
					scntrl.rspL		= addr->wrmotors[0];
					scntrl.rspR		= addr->wrmotors[1];
				case _scntrl_sonar:	//источник управления sonar
					scntrl.spL		= addr->wrmotors[0];
					scntrl.spR		= addr->wrmotors[1];
					if(scntrl.maincntrl != _maincntrl_no)
						break;
					else if(disctLimCntrl())	//функция пересчёта и режима
					{	//проиошло изменение задания и оно персчитано пропорционально расстоянию
						addr->wrmotors[0] 	= scntrl.spL;
						addr->wrspeed_motors[0]	= 1;
						addr->wrmotors[1]	= scntrl.spR;
						addr->wrspeed_motors[1]	= 1;
						addr->scntrl		= _scntrl_sonar;	//захватываем управление
					}
					else
					{
						if(addr->scntrl == _scntrl_sonar)
							addr->scntrl = _scntrl_free;	//отпускаем управление
					}
					break;
				default:
					break;
			}
			//
			//
			addr->sonardistance	= dist;
			addr->sonarradius	= radius.radius;
			addr->timeSonar		= timeSonar;
			//анализ по времени
			if((scntrl.timeSonar - scntrl.timeSonarOld) > _start_time_cntrl)
			{
				if(timeSonar > (scntrl.timeMotorANDservo + _timeDelta))
					addr->statSonar	&= (~(_statSonar_timeServoANDmotor));
				else
					addr->statSonar	|= _statSonar_timeServoANDmotor;
				if(timeSonar > (scntrl.timeCamwork + _timeDelta))
					addr->statSonar	&= (~(_statSonar_timeCamwork));
				else
					addr->statSonar	|= _statSonar_timeCamwork;
				if(timeSonar > (scntrl.timeWSbot + _timeDelta))
					addr->statSonar	&= (~(_statSonar_timeWsbot));
				else
					addr->statSonar	|= _statSonar_timeWsbot;
			}
			//
			if(addr->statSonar & _statSonar_timeServoANDmotor)
			{
				//выполнение сканирования по горизонтали
				//printf("time _statSonar_timeServoANDmotor OK...\n");
				if(scntrl.maincntrl == _maincntrl_scanmapH)
				{
					//printf("CMD scan horisontal...\n");
					switch(addr->scntrl)
					{
						case _scntrl_free:	//нет источника управления
						case _scntrl_wsbot:	//источник wsbot через веб интерфейс
							addr->scntrl	= _scntrl_sonar;
							break;
						case _scntrl_sonar:	//источник управления sonar
							if(!(addr->statSonar & _statSonar_msg_work)) //начало
							{
								//printf("start scan hor...\n");
								addr->wrmotors[0]	= 0;
								addr->wrspeed_motors[0]	= 0;
								addr->wrmotors[1]	= 0;
								addr->wrspeed_motors[1]	= 0;
								memset(&addr->ppd[0], 0, sizeof(PPD[_maxPPD]));
								addr->statSonar 	|= _statSonar_msg_work;
								scntrl.setposH		= _setHposH;
								scntrl.cntsetposH	= 0;
								addr->wrservo[0]	= scntrl.setposH;
								addr->wrservo_speed[0]	= 20;
								addr->wrservo[1]	= 0;
								addr->wrservo_speed[1]	= 5;
							}
							else
							{
								addr->wrmotors[0]	= 0;
								addr->wrspeed_motors[0]	= 0;
								addr->wrmotors[1]	= 0;
								addr->wrspeed_motors[1]	= 0;
								addr->wrservo[0]	= scntrl.setposH;
								addr->wrservo_speed[0]	= 150;
								addr->wrservo[1]	= 0;
								addr->wrservo_speed[1]	= 150;
								addr->statSonar 	|= _statSonar_msg_work;
								if(addr->rdservo[0] == addr->wrservo[0])
								{
									addr->ppd[scntrl.cntsetposH].PH	= addr->rdservo[0];
									addr->ppd[scntrl.cntsetposH].PV	= addr->rdservo[1];
									addr->ppd[scntrl.cntsetposH].D	= dist;
									if(!(scntrl.setposH < _endHposH))
									{
										addr->statSonar 	&= (~(_statSonar_msg_work));
										scntrl.maincntrl	= _maincntrl_no;
										addr->wrservo[0]	= 0;
										addr->wrservo_speed[0]	= 10;
										addr->wrservo[1]	= 0;
										addr->wrservo_speed[1]	= 10;
									}
									scntrl.cntsetposH++;	
									scntrl.setposH			+= _stepHposH;
								}
								//printf("continue scan hor... posH=%i dist=%i\n", scntrl.setposH, dist);
							}
							break; 
						default:
							break;
					}
				}
			}
			sem_post(sem);
		}
		//
		usleep(_sonarsleep);
	}

	return 0;
}

//приближение к препятствию - пересчёт
uint8_t disctLimCntrl(void)
{
	float	prcDist;
	//
	if((dist < _dist_Lcntrl_scznH) && (scntrl.rposH == 0))
	{
		scntrl.maincntrl = _maincntrl_scanmapH;
		return 0;
	}
	else if(!(dist > _dist_Hcntrl))
	{
		prcDist	= (float)(dist - _dist_Lcntrl) / (float)(_dist_Hcntrl - _dist_Lcntrl);
		if(prcDist < 0.0)
			prcDist = 0;
		scntrl.spL = (int16_t)((float)(scntrl.rspL) * prcDist);
		scntrl.spR = (int16_t)((float)(scntrl.rspR) * prcDist);
		printf("dist=%i  prcDist=%0.2f\n", dist, prcDist);
		return 0xFF;
	}
	else
		return 0;
}

