//mb12xx.h

#ifndef _mb12xx_h
#define _mb12xx_h
#include <sys/types.h>

#define _wait_sensor	100000		//ожидание сенсора

/*
******************************************************************************
Изменения:
	04.05.2017	- мелкие коррекции
	05.05.2017	- функции радиуса "пятна" отражения
******************************************************************************
*/

/*
Адрес по умолчанию
default i2c_addr = 0x70 (hex)
*/

/*
параметры по диаграмме направленности
*/


#define _type_diagramm_MB1242_A33	1
#define _type_diagramm_MB1242_A50	2
#define _type_diagramm_MB1242_B33	3
#define _type_diagramm_MB1242_B50	4
#define _type_diagramm_MB1242_C33	5
#define _type_diagramm_MB1242_C50	6
#define _type_diagramm_MB1242_D33	7
#define _type_diagramm_MB1242_D50	8
typedef struct _SSENS_RADIUS
{
	u_int16_t	distance;	//дистанция
	u_int16_t	radius;		//радиус "пятна"
	u_int8_t	type_diagramm;	//тип диаграммы
} SENS_RADIUS;

//
//чтение данных сонара
extern int	mb1242read_sensor(u_int8_t i2c_addr);
//чтение данных сенсора с учётом "радиуса пятна"
extern int	mb1242read_sensorR(u_int8_t i2c_addr, SENS_RADIUS * dat);
//чтение данных сонара в метрической системе
extern float	mb1242read_sensorM(u_int8_t i2c_addr);


#endif

