//bar.c

#include <math.h>
#include <string.h>
#include <pthread.h>
#include "bmp.h"
#include "bar.h"

BARS bars;

//горизонтальное отображение бара
void barH(int16_t x, int16_t y, int16_t w, int16_t h,
	int16_t min, int16_t max, int16_t cur,
	uint8_t RBr, uint8_t GBr, uint8_t BBr,	//цвет болдюра
	uint8_t RF, uint8_t GF, uint8_t BF,	//цвет шкалы
	uint8_t RB, uint8_t GB, uint8_t BB)	//цвет фона
{
	int16_t	x1_clip_old, y1_clip_old, x2_clip_old, y2_clip_old;
	int16_t	X;
	int16_t	delta = max - min;
	float	k = 0.0;
	k = (float)(w - 2) / fabs((float)(delta));
	pthread_mutex_lock(&BMPmutex);
	//сохраним регион
	x1_clip_old = x1_clip;
	y1_clip_old = y1_clip;
	x2_clip_old = x2_clip;
	y2_clip_old = y2_clip;
	//установим регион
	BMP_GSetClip(x, y, x + w, y + h);
	BMP_rect_filled(x + 1, y + 1, x + w - 1, y + h - 1, RB, GB, BB);
	X = x + (int)((float)(k * cur)) + 1;
	BMP_rect_filled(x + 1, y + 1, X, y + h -1, RF, GF, BF);
	BMP_rect(x, y, x + w, y + h, RBr, GBr, BBr);
	//восстановим регион
	BMP_GSetClip(x1_clip_old, y1_clip_old, x2_clip_old, y2_clip_old);
	pthread_mutex_unlock(&BMPmutex);
}

//вертикальное отображение бара
void barV(int16_t x, int16_t y, int16_t w, int16_t h,
	int16_t min, int16_t max, int16_t cur,
	uint8_t RBr, uint8_t GBr, uint8_t BBr,	//цвет болдюра
	uint8_t RF, uint8_t GF, uint8_t BF,	//цвет шкалы
	uint8_t RB, uint8_t GB, uint8_t BB)	//цвет фона
{
	int16_t	x1_clip_old, y1_clip_old, x2_clip_old, y2_clip_old;
	int16_t	Y;
	int16_t	delta = max - min;
	float	k = 0.0;
	k = (float)(h - 2) / fabs((float)(delta));
	pthread_mutex_lock(&BMPmutex);
	//сохраним регион
	x1_clip_old = x1_clip;
	y1_clip_old = y1_clip;
	x2_clip_old = x2_clip;
	y2_clip_old = y2_clip;
	//установим регион
	BMP_GSetClip(x, y, x + w, y + h);
	BMP_rect_filled(x + 1, y + 1, x + w - 1, y + h - 1, RB, GB, BB);
	Y = y + (int)((float)(k * cur)) + 1;
	BMP_rect_filled(x + 1, y + 1, x + w - 1, Y, RF, GF, BF);
	BMP_rect(x, y, x + w, y + h, RBr, GBr, BBr);
	//восстановим регион
	BMP_GSetClip(x1_clip_old, y1_clip_old, x2_clip_old, y2_clip_old);
	pthread_mutex_unlock(&BMPmutex);
}

void barINIT(void)
{
	memset(&bars, 0, sizeof(BARS));
}
