//buttons.h

#ifndef _buttons_h_
#define _buttons_h_
#include <stdint.h>

#define _SZTXT	32	//размер строки кнопки
#define _CNTBT	32	//количество кнопок

//структура одной кнопки
typedef struct _OB
{
	//координаты
	int	x;
	int	y;
	//размер
	int	w;
	int	h;
	//текст
	char	txt[_SZTXT];
	//цвет
	uint8_t	R;
	uint8_t	G;
	uint8_t	B;
	uint8_t	Rt;
	uint8_t	Gt;
	uint8_t	Bt;
	void (*pf)();
	//
	uint8_t	used;
} OB;

//структура кнопок
typedef struct _BUTTONS
{
	int	cntb;		//количество кнопок в структуре
	OB	button[_CNTBT];	//кнопки
} BUTTONS;

extern BUTTONS	buttons;;

extern void buttonPOP(int x, int y, int w, int h, char * txt, 
			uint8_t R, uint8_t G, uint8_t B,
			uint8_t Rt, uint8_t Gt, uint8_t Bt);

extern void buttonPUSH(int x, int y, int w, int h, char * txt, 
			uint8_t R, uint8_t G, uint8_t B,
			uint8_t Rt, uint8_t Gt, uint8_t Bt);

extern void buttonsINIT(void);

extern int buttonCREATE(int x, int y, int w, int h, char * txt, 
			uint8_t R, uint8_t G, uint8_t B, 
			uint8_t Rt, uint8_t Gt, uint8_t Bt,
			void (*f)());

extern uint8_t buttonCTRL(int16_t x, int16_t y, uint8_t flag);

#endif

