//gpsect.c

#include <pthread.h>
#include "bmp.h"
#include "gpsect.h"



//сектор в окружности с мютексом
void gp_circlesecM(int16_t x, int16_t y, int16_t r, int16_t fs, int16_t f, uint8_t R, uint8_t G, uint8_t B)
{
	float fstart, fstop;
	uint8_t R_2 = (R >> 1);
	uint8_t G_2 = (G >> 1);
	uint8_t B_2 = (B >> 1);
	//
	fstart = (float)(f) - ((float)(fs) / 2.0);
	fstop =(float)(f) + ((float)(fs) / 2.0);
	pthread_mutex_lock(&BMPmutex);
	BMP_Circle(x, y, r, R_2, G_2, B_2);
	BMP_Line(x - r, y, x + r, y, R_2, G_2, B_2);
	BMP_Line(x, y - r, x, y + r, R_2, G_2, B_2);
	BMP_sect(x, y, r, 10, (int16_t)(fstart), (int16_t)(fstop), R, G, B);
	pthread_mutex_unlock(&BMPmutex);
} 

//сектор в окружностии
void gp_circlesec(int16_t x, int16_t y, int16_t r, int16_t fs, int16_t f, uint8_t R, uint8_t G, uint8_t B)
{
	float fstart, fstop;
	uint8_t R_2 = (R >> 1);
	uint8_t G_2 = (G >> 1);
	uint8_t B_2 = (B >> 1);
	//
	fstart = (float)(f) - ((float)(fs) / 2.0);
	fstop =(float)(f) + ((float)(fs) / 2.0);
	BMP_Circle(x, y, r, R_2, G_2, B_2);
	BMP_Line(x - r, y, x + r, y, R_2, G_2, B_2);
	BMP_Line(x, y - r, x, y + r, R_2, G_2, B_2);
	BMP_sect(x, y, r, 10, (int16_t)(fstart), (int16_t)(fstop), R, G, B);
} 

//сектор в окружночти - индикатор с мютексом
void gp_circlesec_indM(int16_t x, int16_t y, int16_t r, int16_t fs, int16_t f, uint8_t si, uint8_t R, uint8_t G, uint8_t B)
{
	float fstart, fstop;
	uint8_t R_2 = (R >> 1);
	uint8_t G_2 = (G >> 1);
	uint8_t B_2 = (B >> 1);
	pthread_mutex_lock(&BMPmutex);
	BMP_Circle(x, y, r, R_2, G_2, B_2);
	BMP_Line(x - r, y, x + r, y, R_2, G_2, B_2);
	BMP_Line(x, y - r, x, y + r, R_2, G_2, B_2);
	switch(si)
	{
		case 1:
			BMP_textout("0\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x - FontBits, y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x - r - (FontBits * 3) - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x - ((FontBits * 3)/2) , y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
		case 2:
			BMP_textout("0\0", x, y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x - r - FontBits * 2 - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x - ((FontBits * 3)/2), y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			f = f + 90;
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
		case 3:
			BMP_textout("0\0", x - r - FontBits - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x - FontBits/2, y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x - ((FontBits * 3)/2), y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			f = f + 180;
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
		default:
			BMP_textout("0\0", x - FontBits/2, y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x - ((FontBits * 3)/2), y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x - r - (FontBits * 3) - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			f = f + 270;
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
	}
	BMP_sect(x, y, r, 10, (int16_t)(fstart), (int16_t)(fstop), R, G, B);
	pthread_mutex_unlock(&BMPmutex);
	
}

//сектор в окружночти - индикатор
void gp_circlesec_ind(int16_t x, int16_t y, int16_t r, int16_t fs, int16_t f, uint8_t si, uint8_t R, uint8_t G, uint8_t B)
{
	float fstart, fstop;
	uint8_t R_2 = (R >> 1);
	uint8_t G_2 = (G >> 1);
	uint8_t B_2 = (B >> 1);
	BMP_Circle(x, y, r, R_2, G_2, B_2);
	BMP_Line(x - r, y, x + r, y, R_2, G_2, B_2);
	BMP_Line(x, y - r, x, y + r, R_2, G_2, B_2);
	switch(si)
	{
		case 1:
			BMP_textout("0\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x - FontBits, y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x - r - (FontBits * 3) - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x - ((FontBits * 3)/2) , y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
		case 2:
			BMP_textout("0\0", x, y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x - r - FontBits * 2 - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x - ((FontBits * 3)/2), y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			f = f + 90;
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
		case 3:
			BMP_textout("0\0", x - r - FontBits - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x - FontBits/2, y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x - ((FontBits * 3)/2), y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			f = f + 180;
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
		default:
			BMP_textout("0\0", x - FontBits/2, y - r - FontByts - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("90\0", x + r + FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("180\0", x - ((FontBits * 3)/2), y + r + FontByts/2, R, G, B, 0, 0, 0,  0);
			BMP_textout("270\0", x - r - (FontBits * 3) - FontBits/2, y - FontByts/2, R, G, B, 0, 0, 0,  0);
			f = f + 270;
			fstart = (float)(f) - ((float)(fs) / 2.0);
			fstop =(float)(f) + ((float)(fs) / 2.0);
			break;
	}
	BMP_sect(x, y, r, 10, (int16_t)(fstart), (int16_t)(fstop), R, G, B);
}


