//main.c

#include <stdio.h>
#include <stdint.h>
#include <unistd.h>
#include <math.h>
#include <sys/mman.h>
#include <semaphore.h>
#include <pthread.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include "maindat.h"
#include "main.h"
#include "bmp.h"
#include "bmpfunc.h"
#include "wsserver.h"
#include "workfunc.h"
#include "bmpfunc.h"
#include "objects.h"
#include "gpsect.h"
#include "textbox.h"
#include "config.h"


char 		filenameBMP[32];		//имя файла шаблонного файла BMP
char		worktxt[4096];
uint8_t 	BMP_DUMPr[_BMP_DUMP_SIZE_];
MOT_CONTRL	motCntrl;
//
sem_t 				*semCNTRL;
sem_t 				*semBMP;
pthread_mutex_t         	MainMutex;
pthread_t               	hMainPth;
uint8_t	Cmd, rCmd;
//
int	R,G,B;
time_t	mainTime;

//
uint16_t	statServoANDmotor;
uint16_t	statSonar;
uint16_t	statCamwork;
uint16_t	statWsbot;
uint16_t	statServoANDmotorOld;
uint16_t	statSonarOld;
uint16_t	statCamworkOld;
uint16_t	statWsbotOld;
int16_t		NMSG1;
time_t		timeMSG1;
//
int16_t	NMSG2;
time_t	timeMSG2;
//
time_t	timeSonarMSG_work;

int main(int argc, char *argv[])
{
	int res;
	int scnt = 1;
	//
	//параметры запускаемого потока
        pthread_attr_t  tattr;
        pthread_attr_init(&tattr);
        pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
	//
	rCmd 	= 0;
	Cmd	= 0;
	R 	= 100;
	G 	= 100;
	B 	= 100;
	if(argc < 2)
	{
		printf("{--help}\n");
		return 1;
	}
	while(scnt < argc)
	{
		if(strcmp(argv[scnt], "--help") == 0)
		{
			printf(_help_);
			return 0;
		}
		//дата и версия
	        if(strcmp(argv[scnt], "--version") == 0)
		{
	        	printf("Дата: ");
			printf(_date);
			printf("  Весия: ");
			printf(_version);
			printf("\n");
	                return 0;
	        }
		else if(strcmp(argv[scnt], "--fbmp") == 0)
		{
			scnt++;
			if(!(scnt < argc))
			{
				printf("не задано имя файла шаблонного BMP файла\n");
				return 3;
			}
			memset(&filenameBMP[0], 0, 32);
			strcpy(&filenameBMP[0], argv[scnt]);
		}
		else if(strcmp(argv[scnt], "-p") == 0)
		{
			scnt++;
			if(!(scnt < argc))
			{
				printf("Не задано значение параметроа порта прослушивания!\n");
				return 3;
			}
			wsport = atoi(argv[scnt]);
		}
		else
		{
			printf("{--help}\n");
			return  2;
		}
		scnt++;
	}
	//
	printf("res=%i\n", createSHMcntrl());
	printf("res=%i\n", createSHMbmp());
	shcmd = (SHCMD*)(addrCMD);
	res = startWSserver();
	//
	manControl();
	//
	if(res < 0)
		return 4;
	//mutex create
        if(!(pthread_mutex_init(&MainMutex,NULL) == 0))
                return 5;
	pthread_create(&hMainPth,NULL,(void*) MainPth,NULL);
	//pthread_create(&hMainPth,&tattr,(void*) MainPth,NULL);
	//
	while(1)
	{
		mainTime	= time(NULL);
		pthread_mutex_lock(&MainMutex);
		memcpy(&BMP_DUMP[0], &BMP_DUMPr[0], bhfi.bfSize);
		//MainBMP();
		rectangle(0, 0, 639, 479, 64, 64, 64);
		objsCNRTL(shcmd);
		manInd();
		//rwSHMcntrl();
		pthread_mutex_unlock(&MainMutex);
		rwSHMcntrl();
		usleep(_MainSleep);
	}
	return 0;
}

//инициализация элементов ручного управления
void manControl(void)
{
	buttonsINIT();
	buttonCREATE(55, 3, 80, 20, "NO TURN\0", 192, 255, 255, 0,0,0, &cmdNoTurn);
	buttonCREATE(3, 3, 50, 20, "STOP\0", 192, 255, 255, 0,0,0, &cmdSTOP);
	buttonCREATE(3, 455, 30, 20, ">0<\0", 192, 255, 255, 0,0,0, &cmdPosNull);
	slidersINIT();
	sliderCREATE(38,455,200,20, 45,-45, (int16_t*)(&motCntrl.camHposition), 255,255,255, 127,127,127);
	sliderCREATE(3, 250,20,200, -30, 40, (int16_t*)(&motCntrl.camVposition), 255,255,255, 127,127,127);
	sliderCREATE(3, 30, 20,150, 0,255, (int16_t*)(&motCntrl.motSpeed), 255,255,255, 127,127,127);
	sliderCREATE(145,5,200,20, -255,255, (int16_t*)(&motCntrl.motTurn), 255,255,255, 127,127,127);
	//
	txtboxInit();
	NMSG1 = txtboxCreate(250,200, 380,200, 255,255,255, 0);
	NMSG2 = txtboxCreate(250,40, 380,100, 255,255,255, 0);
}

//индикация положения сонара и камеры
void indCamSonar(void)
{
	char	valline[64];
	BMP_textout("pos.horizontal:", 50, 440, 255,255,255, 0,0,0, 0);
	gp_circlesec_ind(120, 400, 25, 45, motCntrl.RDcamHposition, 2, 255, 255, 255);
	BMP_textout("pos.vertical  :", 50, 340, 255,255,255, 0,0,0, 0);
	gp_circlesec_ind(120, 300, 25, 45, motCntrl.RDcamVposition, 1, 255, 255, 255);
	BMP_textout("position control", 50, 245, 255,255,255, 0,0,0, 0);
	memset(&valline[0], 0, 10);
	sprintf(&valline[0], "%i", motCntrl.RDcamHposition);
	BMP_textout(&valline[0], 180, 440, 255,255,255, 0,0,0, 0);
	memset(&valline[0], 0, 10);
	sprintf(&valline[0], "%i", motCntrl.RDcamVposition);
	BMP_textout(&valline[0], 180, 340, 255,255,255, 0,0,0, 0);
}

//сообщения
void fMSG(void)
{
	if(statServoANDmotor != statServoANDmotorOld)
	{
		txtboxOn(NMSG1, 0xFF);
		sprintf(&worktxt[0],"%lli\n", mainTime);
		txtboxAddtext(&worktxt[0], NMSG1);
		sprintf(&worktxt[0],"%s","MSG: \"servoANDmotor\":\n");
		txtboxAddtext(&worktxt[0], NMSG1);
		if(!(statServoANDmotor & _statServoANDmotor_timeSonar))
		{
			sprintf(&worktxt[0],"%s", "No time from module \"sonar\" - ERR\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		else
		{
			sprintf(&worktxt[0],"%s", "Time from module \"sonar\" - OK\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		if(!(statServoANDmotor & _statServoANDmotor_timeCamwork))
		{
			sprintf(&worktxt[0],"%s", "No time from module \"camwork\" - ERR\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		else
		{
			sprintf(&worktxt[0],"%s", "Time from module \"camwork\" - OK\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		if(!(statServoANDmotor & _statServoANDmotor_MB03conn))
		{
			sprintf(&worktxt[0],"%s", "No cmd 3 Modbus RTU - read params... ERR CON\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		else
		{
			sprintf(&worktxt[0],"%s", "Cmd 3 Modbus RTU - read params... CON OK\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		if(!(statServoANDmotor & _statServoANDmotor_MB10conn))
		{
			sprintf(&worktxt[0],"%s", "No cmd 16 Modbus RTU - wriete params... ERR CON\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		else
		{
			sprintf(&worktxt[0],"%s", "Cmd 16 Modbus RTU - wriete params... CON OKs\n");
			txtboxAddtext(&worktxt[0], NMSG1);
		}
		statServoANDmotorOld	= statServoANDmotor;
	}
	//
}

//индикация сканирования (сонара)
void indScan(void)
{
	int	cnt	= 0;
	int	xc1	= x1_clip;
	int	yc1	= y1_clip;
	int	xc2	= x2_clip;
	int	yc2	= y2_clip;
	int16_t X1, Y1, X2, Y2;
	float	firad;
	BMP_GSetClip(_isNullX - 200, _isNullY, _isNullX + 200, _isNullY + 300); 
	BMP_rect(_isNullX - 200, _isNullY, _isNullX + 200, _isNullY + 300, 96,96,96);
	while(cnt < 50)
	{
		//printf("motCntrl.ppd[cnt].PH=%i  motCntrl.ppd[cnt].D=%i\n", motCntrl.ppd[cnt].PH, motCntrl.ppd[cnt].D);
		if(motCntrl.ppd[cnt].D == 0)
			break;
		BMP_vect(_isNullX, _isNullY, motCntrl.ppd[cnt].D, motCntrl.ppd[cnt].PH + 90, 64, 64, 64);
		firad = (float)(motCntrl.ppd[cnt].PH + 90) / BMP_RAD;
		X1 = (int16_t)((float)(motCntrl.ppd[cnt].D) * cos(firad)) + _isNullX;
		Y1 = (int16_t)((float)(motCntrl.ppd[cnt].D) * sin(firad)) + _isNullY;
		//BMP_Circle(X1, Y1, 1, 255,255,255);
		if(cnt > 0)
		{
			firad = (float)(motCntrl.ppd[cnt - 1].PH + 90) / BMP_RAD;
			X2 = (int16_t)((float)(motCntrl.ppd[cnt - 1].D) * cos(firad)) + _isNullX;
			Y2 = (int16_t)((float)(motCntrl.ppd[cnt - 1].D) * sin(firad)) + _isNullY;
			BMP_Line(X1,Y1,X2,Y2,255,255,255);
		}
		//
		cnt++;
	}
	BMP_Circle(_isNullX, _isNullY, 20, 255,255,255);
	BMP_GSetClip(xc1, yc1, xc2, yc2);
}

//реализация индикации
void manInd(void)
{
	char	valline[64];
	if((motCntrl.rdmotLspeed != 0) || (motCntrl.rdmotRspeed != 0))
	{
		sprintf(&valline[0], "L: %i", motCntrl.rdmotLspeed);
		BMP_textout(&valline[0], 80, 55, 255,255,255, 0,0,0, 0);
		sprintf(&valline[0], "R: %i", motCntrl.rdmotRspeed);
		BMP_textout(&valline[0], 160, 55, 255,255,255, 0,0,0, 0);
		BMP_textout("move control (set speed)", 50, 40, 255,255,255, 0,0,0, 0);
	}
	sprintf(&valline[0], "SONAR: dist: %i cm", motCntrl.sonardistance); 
	BMP_textout(&valline[0], 365, 8, 255,255,255, 0,0,0, 0);
	switch(motCntrl.scntrl)
	{
		case _scntrl_free:
			BMP_textout("CONTROL: FREE",365,18,255,255,255, 0,0,0, 0);
			break;
		case _scntrl_servoANDmotors:
			BMP_textout("CONTROL: servoANDmotor",365,18,255,255,255, 0,0,0, 0);
			break;
		case _scntrl_wsbot:
			BMP_textout("CONTROL: wsbot",365,18,255,255,255, 0,0,0, 0);
			break;
		case _scntrl_sonar:
			BMP_textout("CONTROL: sonar",365,18,255,255,255, 0,0,0, 0);
			break;
		default:
			BMP_textout("CONTROL: UNKNOWN",365,18,255,255,255, 0,0,0, 0);
			break;
	}
	//
	if((mainTime - timeSonarMSG_work) < _waittimeSonarMSG_work)
	{
		if(statSonar &_statSonar_msg_work)
			timeSonarMSG_work	= mainTime;
		indScan();
	}
	else if((mainTime - timeMSG1) > _waitMSG)
	{
		if((motCntrl.RDcamHposition != motCntrl.camHposition) ||
		(motCntrl.RDcamVposition != motCntrl.camVposition))
			indCamSonar();
		txtboxOn(NMSG1, 0);
		txtboxOn(NMSG2, 0);
	}
	else
	{
		fMSG();
		txtboxRelease();
	}
 }

void cmdNoTurn(void)
{
	motCntrl.motTurn	= 0;
	rwSHMcntrl();
}

void cmdSTOP(void)
{
	motCntrl.motSpeed	= 0;
	rwSHMcntrl();
}

void cmdPosNull(void)
{
	motCntrl.camHposition	= 0;
	motCntrl.camVposition	= 0;
	rwSHMcntrl();
}

int createSHMcntrl(void)
{
	//
	//память - создание
        if ( (shmCMD = shm_open(gdatSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 1;
	if ( ftruncate(shmCMD, gdatSHARED_MEMORY_OBJECT_SIZE + 1) == -1 ) 
                return 2;
	if ( (addrCMD = mmap(0, gdatSHARED_MEMORY_OBJECT_SIZE + 1, PROT_WRITE|PROT_READ, MAP_SHARED, shmCMD, 0)) == (u_int8_t*)-1 )
                return 3;
	//семафор - создание
	if ( (semCNTRL = sem_open(gdatSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
		return 4;
	sem_post(semCNTRL);
	usleep(500000);
	sem_wait(semCNTRL);
	//
	memset(addrCMD, 0, gdatSHARED_MEMORY_OBJECT_SIZE);
	sem_post(semCNTRL);
	return 0;
}

int rwSHMcntrl(void)
{
	GDATA1	*gd;
	int16_t	motL;
	int16_t	motR;
	//
	motL	= motCntrl.motSpeed + motCntrl.motTurn;
	if(motL > 255)
		motL	= 255;
	else if(motL < -255)
		motL	= -255;
	motR	= motCntrl.motSpeed - motCntrl.motTurn;
	if(motR > 255)
		motR	= 255;
	else if(motR < -255)
		motR	= -255;
	//
	sem_wait(semCNTRL);
	//
	gd = (GDATA1*)(addrCMD);
	gd->timeWSbot			= mainTime;
	#if(_rwSHMcntrl_dbg > 0)
	printf("dbg wsbot: _rwSHMcntrl_dbg : gd->scntrl = %i - источник упраления\n", gd->scntrl);
	#endif
	motCntrl.scntrl	= gd->scntrl;
	switch(gd->scntrl)
	{
		case _scntrl_free:
			if(shcmd->Cmd)
			{
				gd->wrmotors[_MwrmotorL]	= motL;
				gd->wrspeed_motors[_MwrmotorL]	= 10;
				gd->wrmotors[_MwrmotorR]	= motR;
				gd->wrspeed_motors[_MwrmotorR]	= 10;
				gd->wrservo[_MwrservoH]		= motCntrl.camHposition;
				gd->wrservo_speed[_MwrservoH]	= 100;
				gd->wrservo[_MwrservoV]		= motCntrl.camVposition;
				gd->wrservo_speed[_MwrservoV]	= 100;
				gd->scntrl			= _scntrl_wsbot;
				shcmd->Cmd			= 0;
			}
			else
			{
				if((motCntrl.rdmotLspeed == 0) || (motCntrl.rdmotRspeed == 0))
				{
					motCntrl.motSpeed	= 0;
					motCntrl.motTurn	= 0;
				}
				motCntrl.camHposition		= gd->wrservo[_MwrservoH];
				motCntrl.camVposition		= gd->wrservo[_MwrservoV];
			}
			break;
		case _scntrl_wsbot:
			if(shcmd->Cmd)
			{
				//printf("main.c rwSHMcntrl Cmd ON\n");
				gd->wrmotors[_MwrmotorL]	= motL;
				gd->wrspeed_motors[_MwrmotorL]	= 10;
				gd->wrmotors[_MwrmotorR]	= motR;
				gd->wrspeed_motors[_MwrmotorR]	= 10;
				gd->wrservo[_MwrservoH]		= motCntrl.camHposition;
				gd->wrservo_speed[_MwrservoH]	= 100;
				gd->wrservo[_MwrservoV]		= motCntrl.camVposition;
				gd->wrservo_speed[_MwrservoV]	= 100;
				gd->scntrl			= _scntrl_wsbot;
				shcmd->Cmd			= 0;
			}
			break;
		case _scntrl_servoANDmotors:
			if((motCntrl.rdmotLspeed == 0) || (motCntrl.rdmotRspeed == 0))
			{
				motCntrl.motSpeed	= 0;
				motCntrl.motTurn	= 0;
			}
			motCntrl.camHposition		= gd->wrservo[_MwrservoH];
			motCntrl.camVposition		= gd->wrservo[_MwrservoV];
			shcmd->Cmd			= 0;
			break;
		case _scntrl_sonar:
			if((motCntrl.rdmotLspeed == 0) || (motCntrl.rdmotRspeed == 0))
			{
				motCntrl.motSpeed	= 0;
				motCntrl.motTurn	= 0;
			}
			motCntrl.camHposition		= 0;
			motCntrl.camVposition		= 0;
			shcmd->Cmd			= 0;
			break;
		default:
			if((motCntrl.rdmotLspeed == 0) || (motCntrl.rdmotRspeed == 0))
			{
				motCntrl.motSpeed	= 0;
				motCntrl.motTurn	= 0;
			}
			motCntrl.camHposition		= gd->wrservo[_MwrservoH];
			motCntrl.camVposition		= gd->wrservo[_MwrservoV];
			break;
	}
	//
	motCntrl.RDcamHposition		= gd->rdservo[_MwrservoH];
	motCntrl.RDcamVposition		= gd->rdservo[_MwrservoV];
	motCntrl.rdmotLspeed		= gd->rdmotors[_MwrmotorL];
	motCntrl.rdmotRspeed		= gd->rdmotors[_MwrmotorR];
	motCntrl.sonardistance		= gd->sonardistance;
	memcpy(&motCntrl.ppd[0], &gd->ppd[0], sizeof(PPD) * _maxPPD);
	//
	if(gd->statServoANDmotor != statServoANDmotor)
	{
		printf("MSG:statServoANDmotor\n");
		timeMSG1		= mainTime;
		statServoANDmotor	= gd->statServoANDmotor;
	}
	if(gd->statSonar != statSonar)
	{
		statSonar		= gd->statSonar;
		if(statSonar &_statSonar_msg_work)
			timeSonarMSG_work	= mainTime;
		else
			timeMSG1		= mainTime;
	}
	if(gd->statCamwork != statCamwork)
	{
		timeMSG1		= mainTime;
		statCamwork		= gd->statCamwork;
	}
	sem_post(semCNTRL);
	return 0;
}

//разделяемая память - формирование
int createSHMbmp(void)
{
	//определяем параметры шаблона BMP (размер)
	BMP_FileAnalise(&filenameBMP[0], &BMP_DUMP[0]);
	//память - создание
        if ( (shmBMP = shm_open(bmpSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 1;
	if ( ftruncate(shmBMP, bhfi.bfSize + 1) == -1 ) 
                return 2;
	if ( (addrBMP = mmap(0, bhfi.bfSize + 1, PROT_WRITE|PROT_READ, MAP_SHARED, shmBMP, 0)) == (u_int8_t*)-1 )
                return 3;
	//семафор - создание
	if ( (semBMP = sem_open(bmpSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
		return 4;
	sem_post(semBMP);
	usleep(500000);
	sem_wait(semBMP);
	memcpy((uint8_t*)(addrBMP), &BMP_DUMP[0], bhfi.bfSize);
	sem_post(semBMP);

	return 0;
}


void MainBMP(void)
{
	sem_wait(semBMP);
	//memcpy(&BMP_DUMPr[0], (uint8_t*)(addrBMP), bhfi.bfSize);
	memcpy(&BMP_DUMP[0], (uint8_t*)(addrBMP), bhfi.bfSize);
	sem_post(semBMP);
}


//разделяемая память - обращение
void MainPth(void)
{
	while(1)
	{
		pthread_mutex_lock(&MainMutex);
		sem_wait(semBMP);
		memcpy(&BMP_DUMPr[0], (uint8_t*)(addrBMP), bhfi.bfSize);
		sem_post(semBMP);
		pthread_mutex_unlock(&MainMutex);
		usleep(_MainPthSleep);
	}
	pthread_exit(0);
}


