//maindat.h

#ifndef _maindat_h_
#define _maindat_h_
#include <stdint.h>
//#include "motors.h"

/*
	21.10.2018	- дбавлены параметры пеленга и дистанциия о сонара
	20.10.2018
	17.10.2018
	16.10.2018
	15.10.2028
	14.10.2018
	10.10.2018	- добалены параметры для сонара
	03.10.2018
	27.09.2018
	23.09.2018
	22.09.2018
	13.09.2018
	09.09.2018
*/

//параметры для управления от сонара
#define	_dist_Hcntrl		105	//максимальная дистанция контроля
#define _dist_Lcntrl		35	//минимальная дистанция контроля

typedef struct	_PPD
{
	int16_t	PH;	//пеленг по горизонтали
	int16_t	PV;	//пеленг по вертикали
	int16_t	D;	//дистанция
} PPD;


//глобальная структура данных
#define	_Mcnt_motmove		2	//правые и левые моторы
#define _MwrmotorL		0	//левые колёса
#define _MwrmotorR		1	//правые колёсв
#define _Mcnt_servomove		2	//горизонтальная и вертикальная сервомашины
#define _MwrservoH		0	//позиционирование по горизонтали
#define _MwrservoV		1	//позиционирование по вертикали
typedef struct _GDATA1
{
	/* 64-битные параметры */
#define _timeDelta					3
	uint64_t	timeMotorANDservo;			//время от моторов и сервомашин
	uint64_t	timeSonar;				//время от Сонара
	uint64_t	timeCamwork;				//время от камеры
	uint64_t	timeWSbot;				//время от websocket
	uint64_t	timeCamcntrl;				//время от управления локальной камеры
	uint64_t	timeCluster;				//время от управления клатером 
	/* 16-битные параметры */
	int16_t		wrmotors[_Mcnt_motmove];		//задание для моторов колёс
	uint16_t	wrspeed_motors[_Mcnt_motmove];		//задание времени реакции моторов
	int16_t		wrservo[_Mcnt_servomove];		//задание позиционирования
	uint16_t	wrservo_speed[_Mcnt_servomove];		//задание втемени позиционирования
	int16_t		rdmotors[_Mcnt_motmove];		//текщее задание для моторов колёс
	int16_t		rdservo[_Mcnt_servomove];		//текущее задание позиционирования
	int16_t		sonardistance;				//дальномер - дистанция см
	int16_t		sonarradius;				//дальномер - радиус "пятна" см
#define _maxPPD		280
	PPD		ppd[_maxPPD];				//массив пеленга и дистануии
	//
#define _statServoANDmotor_timeServoANDmotor		0x0001	//есть время от servoANDmotor (резерв)
#define _statServoANDmotor_timeSonar			0x0002	//есть время от sonar
#define _statServoANDmotor_timeCamwork			0x0004	//есть время от camwork
#define _statServoANDmotor_timeWsbot			0x0008	//есть время от wsbot
#define _statServoANDmotor_timeCamcntl			0x0010	//есть время от camcntrl
#define _statServoANDmotor_timeCluster			0x0020	//есть время от cluster
#define _statServoANDmotor_MB03conn			0x0100	//есть связь чтения по ModbusRTU
#define _statServoANDmotor_MB10conn			0x0200	//есть связь записи по ModbusRTU
#define _statServoANDmotor_msg_err			0x1000	//сообщение об ошибке
	uint16_t	statServoANDmotor;			//регистр статуса servoANDmotor
#define _statSonar_timeServoANDmotor			0x0001	//есть время от servoANDmotor
#define _statSonar_timeSonar				0x0002	//есть время от sonar (резерв)
#define _statSonar_timeCamwork				0x0004	//есть время от camwork
#define _statSonar_timeWsbot				0x0008	//есть время от wsbot
#define _statSonar_timeCamcntl				0x0010	//есть время от camcntrl
#define _statSonar_timeCluster				0x0020	//есть время от cluster
#define _statSonar_msg_err				0x1000	//сообщение об ошибке
#define _statSonar_msg_work				0x2000	//сообщение о выполнении автономных действий	
	uint16_t	statSonar;				//регистр статуса sonar
#define _statCamwork_timeServoANDmotor			0x0001	//есть время от servoANDmotor
#define _statCamwork_timeSonar				0x0002	//есть время от sonar
#define _statCamwork_timeCamwork			0x0004	//есть время от camwork (резерв)
#define _statCamwork_timeWsbot				0x0008	//есть время от wsbot
#define _statCamwork_timeCamcntl			0x0010	//есть время от camcntrl
#define _statCamwork_timeCluster			0x0020	//есть время от cluster
#define _statCamwork_msg_err				0x1000	//сообщение об ошибке
#define _statCamwork_msg_work				0x2000	//сообщение о выполнении автономных действий	
	uint16_t	statCamwork;				//регистр статуса camwork
#define _statWsbot_timeServoANDmotor			0x0001	//есть время от servoANDmotor
#define _statWsbot_timeSonar				0x0002	//есть время от sonar
#define _statWsbot_timeCamwork				0x0004	//есть время от camwork
#define _statWsbot_timeWsbot				0x0008	//есть время от wsbot (резерв)
#define _statWsbot_timeCamcntl				0x0010	//есть время от camcntrl
#define _statWsbot_timeCluster				0x0020	//есть время от cluster
#define _statCamwork_msg_err				0x1000	//сообщение об ошибке	
	uint16_t	statWsbot;				//регист статуса wsbot
#define _camcntrl_timeServoANDmotor			0x0001	//есть время от servoANDmotor
#define _camcntrl_timeSonar				0x0002	//есть время от sonar
#define _camcntrl_timeCamwork				0x0004	//есть время от camwork
#define _camcntrl_timeWsbot				0x0008	//есть время от wsbot (резерв)
#define _camcntrl_timeCamcntl				0x0010	//есть время от camcntrl
#define _camcntrl_timeCluster				0x0020	//есть время от cluster
#define _camntrl_msg_err				0x1000	//сообщение об ошибке
	uint16_t	statCamcntrtl;				//регист статуса camntrl
	//8-ми битные параметры
	uint8_t		scntrl;					//источник управления
} GDATA1;

//описание status1
#define _status1_sonar_ok	0x0001				//сонар в работе
#define _status1_drive_ok	0x0002				//управление приводами в действии
#define _status1_servo_pos	0x0080				//блоктровка ро положению сервомашин
//описание scntrl
#define _scntrl_free		0x00				//никем не управляется
#define	_scntrl_servoANDmotors	0x01				//локальное управление самих приводов
#define	_scntrl_wsbot		0x02				//управление по websocket
#define _scntrl_sonar		0x03				//управление по sonars
#define _cntnrl_camcntrl	0x04				//управление от камеры локально
#define _scntrl_cluster		0x05				//управление от клатера
//SHM приводов
#define gdatSEMAPHORE_NAME			"/gdat_semaphore"
#define gdatSHARED_MEMORY_OBJECT_NAME		"gdat_memory"
#define gdatSHARED_MEMORY_OBJECT_SIZE 		sizeof(GDATA1)
//SHM картинки BMP
#define bmpSEMAPHORE_NAME			"/gdat_bmp"
#define bmpSHARED_MEMORY_OBJECT_NAME		"bmp_memory"

#endif

