//slider.h

#ifndef _slider_h_
#define _slider_h_

#define _CNTSLDR	32	//количество элементов

typedef struct _OS
{
	//координаты
	int	x;
	int	y;
	//размер
	int	w;
	int	h;
	//
	uint8_t	fv;		//флаг вертикального слайдера
	//
	int16_t	min;
	int16_t	max;
	int16_t	*val;
	float	fdelta;
	int16_t	delta;
	float	k;
	//цвет
	uint8_t	RF;
	uint8_t	GF;
	uint8_t	BF;
	uint8_t	RB;
	uint8_t	GB;
	uint8_t	BB;
	//
	uint8_t	used;
} OS;

typedef struct _SLIDERS
{
	int	cntslrd;
	uint8_t	keyOn;
	OS	slider[_CNTSLDR];
} SLIDERS;

extern SLIDERS 	sliders;

extern __inline void sliderH(int16_t x, int16_t y, int16_t w, int16_t h,
	int16_t min, float k, int16_t cur,
	uint8_t RF, uint8_t GF, uint8_t BF,
	uint8_t RB, uint8_t GB, uint8_t BB);

extern __inline void sliderV(int16_t x, int16_t y, int16_t w, int16_t h,
	int16_t min, float k, int16_t cur,
	uint8_t RF, uint8_t GF, uint8_t BF,
	uint8_t RB, uint8_t GB, uint8_t BB);

extern void slidersINIT(void);

extern int sliderCREATE(int16_t x, int16_t y, int16_t w, int16_t h,
		int16_t min, int16_t max, int16_t * par,
		uint8_t RF, uint8_t GF, uint8_t BF,
		uint8_t RB, uint8_t GB, uint8_t BB);

extern uint8_t sliderCTRL(int16_t x, int16_t y, uint8_t flag);

#endif

