//textbox.c

#include <stdio.h>
#include <string.h>
#include "bmp.h"
#include "textbox.h"

TXTBOX	txtbox;

//инициализация
void txtboxInit(void)
{
	memset(&txtbox, 0, sizeof(TXTBOX));
	
}

//включение/выключение отображения элемента
int16_t	txtboxOn(uint8_t dnum, uint8_t on)
{
	if(!(dnum < txtbox.dtcnt))
		return -1;
	txtbox.dtxt[dnum].txton	= on;
	return 0;
}

//создание текстового элемента
int16_t	txtboxCreate(int16_t x,
			int16_t y,
			int16_t szx,
			int16_t	szy,
			uint8_t FR, 
			uint8_t FG, 
			uint8_t FB,
			uint8_t border
			)
{
	int16_t cnt	= 0;
	while(cnt < _txtboxCnt)
	{
		if(!(txtbox.dtxt[cnt].txtflag))
		{
			txtbox.dtxt[cnt].txtflag	= 0xFF;	//занимаем
			txtbox.dtxt[cnt].txton		= 0xFF;	//включаем
			txtbox.dtxt[cnt].border		= border;
			txtbox.dtxt[cnt].Xpos		= x;
			txtbox.dtxt[cnt].Ypos		= y;
			txtbox.dtxt[cnt].Xsz		= szx;
			txtbox.dtxt[cnt].Ysz		= szy;
			txtbox.dtxt[cnt].FR		= FR;
			txtbox.dtxt[cnt].FG		= FG;
			txtbox.dtxt[cnt].FB		= FB;
			//
			txtbox.dtcnt++;
			//
			return cnt;
		}
		cnt++;
	}
	return -1;
}

//очистка текста
//dnum - номер текстового элемента
int16_t txtboxTxtClr(uint8_t dnum)
{
	if(!(dnum < txtbox.dtcnt))
		return -1;
	txtbox.dtxt[dnum].txtaddr 	= 0;
	txtbox.dtxt[dnum].cntsym 	= 0;
	txtbox.dtxt[dnum].cntstr 	= 0;
	memset(&txtbox.dtxt[dnum].txt[0], 0, _texboxSzStr);
	return 0;
}

//запись текста в элемент
int16_t	txtboxSettext(char * txt, uint8_t dnum)
{
	int16_t	cnt	= 0;
	int16_t	lcnt;
	char	sym;
	char	str[_texboxSzStr];
	if(!(dnum < txtbox.dtcnt))
		return -1;
	memset(&txtbox.dtxt[dnum].txt[0], 0, _texboxSzStr);
	txtbox.dtxt[dnum].txtaddr 	= 0;
	txtbox.dtxt[dnum].cntsym 	= 0;
	txtbox.dtxt[dnum].cntstr 	= 0;
	while(txtbox.dtxt[dnum].txtaddr < _texboxSzStr)
	{
		sym								= (*(char*)(txt + cnt));
		if(sym == '\0')
			break;
		else if(sym == '\n')
		{
			txtbox.dtxt[dnum].cntsym				= 0;
			txtbox.dtxt[dnum].txt[txtbox.dtxt[dnum].txtaddr]	= sym;
			txtbox.dtxt[dnum].txtaddr++;
			txtbox.dtxt[dnum].cntstr++;
		}
		else if(!(((txtbox.dtxt[dnum].cntsym * FontBits) +  _deltaEndX) <  txtbox.dtxt[dnum].Xsz))
		{
			txtbox.dtxt[dnum].cntsym				= 0;
			txtbox.dtxt[dnum].txt[txtbox.dtxt[dnum].txtaddr]	= '\n';
			txtbox.dtxt[dnum].txtaddr++;
			txtbox.dtxt[dnum].cntstr++;
		}
		else
		{
			txtbox.dtxt[dnum].cntsym++;
			txtbox.dtxt[dnum].txt[txtbox.dtxt[dnum].txtaddr]	= sym;
			txtbox.dtxt[dnum].txtaddr++;
		}
		//
		if(!(((txtbox.dtxt[dnum].cntstr * (FontByts + _deltastr)) + _deltaEndY) < txtbox.dtxt[dnum].Ysz))
		{
			lcnt	= 0;
			while(lcnt < _texboxSzStr)
			{
				if(txtbox.dtxt[dnum].txt[lcnt] == '\n')
				{
					lcnt++;
					txtbox.dtxt[dnum].cntstr--;
					memset(&str[0], 0, _texboxSzStr);
					memcpy(&str[0], &txtbox.dtxt[dnum].txt[lcnt], _texboxSzStr - lcnt);
					memset(&txtbox.dtxt[dnum].txt[0], 0, _texboxSzStr);
					memcpy(&txtbox.dtxt[dnum].txt[0], &str[0], _texboxSzStr);
					txtbox.dtxt[dnum].txtaddr -= lcnt;
					break;
				}
				lcnt++;
			}
		}
		cnt++;
	}
	return cnt;
}

//добавление текста в элемент
int16_t	txtboxAddtext(char * txt, uint8_t dnum)
{
	int16_t	cnt	= 0;
	int16_t	lcnt;
	char	sym;
	char	str[_texboxSzStr];
	if(!(dnum < txtbox.dtcnt))
		return -1;
	while(txtbox.dtxt[dnum].txtaddr < _texboxSzStr)
	{
		sym								= (*(char*)(txt + cnt));
		if(sym == '\0')
			break;
		else if(sym == '\n')
		{
			txtbox.dtxt[dnum].cntsym				= 0;
			txtbox.dtxt[dnum].txt[txtbox.dtxt[dnum].txtaddr]	= sym;
			txtbox.dtxt[dnum].txtaddr++;
			txtbox.dtxt[dnum].cntstr++;
		}
		else if(!(((txtbox.dtxt[dnum].cntsym * FontBits) +  _deltaEndX) <  txtbox.dtxt[dnum].Xsz))
		{
			txtbox.dtxt[dnum].cntsym				= 0;
			txtbox.dtxt[dnum].txt[txtbox.dtxt[dnum].txtaddr]	= '\n';
			txtbox.dtxt[dnum].txtaddr++;
			txtbox.dtxt[dnum].cntstr++;
		}
		else
		{
			txtbox.dtxt[dnum].cntsym++;
			txtbox.dtxt[dnum].txt[txtbox.dtxt[dnum].txtaddr]	= sym;
			txtbox.dtxt[dnum].txtaddr++;
		}
		//
		if(!(((txtbox.dtxt[dnum].cntstr * (FontByts + _deltastr)) + _deltaEndY) < txtbox.dtxt[dnum].Ysz))
		{
			lcnt	= 0;
			while(lcnt < _texboxSzStr)
			{
				if(txtbox.dtxt[dnum].txt[lcnt] == '\n')
				{
					lcnt++;
					txtbox.dtxt[dnum].cntstr--;
					memset(&str[0], 0, _texboxSzStr);
					memcpy(&str[0], &txtbox.dtxt[dnum].txt[lcnt], _texboxSzStr - lcnt);
					memset(&txtbox.dtxt[dnum].txt[0], 0, _texboxSzStr);
					memcpy(&txtbox.dtxt[dnum].txt[0], &str[0], _texboxSzStr);
					txtbox.dtxt[dnum].txtaddr -= lcnt;
					break;
				}
				lcnt++;
			}
		}
		//
		cnt++;
	}
	return cnt;
}

//вывод элемента txtbox на экран
void	txtboxOut(uint8_t dnum)
{
	uint16_t cnt	= 0;
	uint16_t cntsym	= 0;
	uint16_t cntstr	= 0;
	uint8_t	 sym;
	//отображаем бордюр
	if(txtbox.dtxt[dnum].border)
		BMP_rect(txtbox.dtxt[dnum].Xpos - 3, txtbox.dtxt[dnum].Ypos - 3, 
		txtbox.dtxt[dnum].Xpos + txtbox.dtxt[dnum].Xsz + 3, 
		txtbox.dtxt[dnum].Ypos + txtbox.dtxt[dnum].Ysz + 3, 
		txtbox.dtxt[dnum].FR, txtbox.dtxt[dnum].FG, txtbox.dtxt[dnum].FB);
	//	
	while(cnt < txtbox.dtxt[dnum].txtaddr)
	{
		//printf("TEXT:%s\n", &txtbox.dtxt[dnum].txt[0]);
		sym	= txtbox.dtxt[dnum].txt[cnt];
		if(sym == '\0')
			break;
		else if(sym == '\n')
		{
			cntsym	= 0;
			cntstr++;
			cnt++;
			continue;
		}
		BMP_outchar(sym,
		txtbox.dtxt[dnum].Xpos + (cntsym * FontBits),
		txtbox.dtxt[dnum].Ypos + txtbox.dtxt[dnum].Ysz - FontByts - ((FontByts +_deltastr) * cntstr),
		txtbox.dtxt[dnum].FR,
		txtbox.dtxt[dnum].FG,
		txtbox.dtxt[dnum].FB,
		0,0,0,0);
		cnt++;
		cntsym++;
	}
}

//реализация вывода
void	txtboxRelease(void)
{
	int8_t	cnt	= 0;
	while(cnt < txtbox.dtcnt)
	{
		if(txtbox.dtxt[cnt].txton)
			txtboxOut(cnt);
		cnt++;
	}
}


