//texbox.h

#ifndef _texbox_h_
#define _texbox_h_

#include <stdint.h>

#define _txtboxCnt	16	//количество элементов
#define _texboxSzStr	4096	//длина строки элемента
#define _deltastr	3	//интервал между строками pix
#define _deltaEndX	5	//оганиечение конца строки pix
#define _deltaEndY	5	//оганиечение конца строкs pix

typedef struct	_oTXTBOX
{
	int16_t		Xpos;			//координата X (левй нижний угол)
	int16_t		Ypos;			//координата Y (левй нижний угол)
	int16_t		Xsz;			//размер по X
	int16_t		Ysz;			//размер по Y
	int16_t		stepX;			//шаг по X в пикс.
	int16_t		stepY;			//шаг по Y в пикс.
	int16_t		txtaddr;		//указатель на символ
	int16_t		cntsym;			//счётчик в строке
	int16_t		cntstr;			//счётчик строк
	uint8_t		txtflag;		//флаг занятости
	uint8_t		txton;			//флаг включения
	uint8_t		border;			//бордюр
	uint8_t 	FR; 			//R цвет текста
	uint8_t 	FG; 			//G цвет текста
	uint8_t 	FB;			//B цвет текста
	char		txt[_texboxSzStr];	//строка элемента	
} oTXTBOX;

typedef struct _TXTBOX
{
	uint8_t		dtcnt;			//количество элементов
	oTXTBOX		dtxt[_txtboxCnt];	//массив элементов
} TXTBOX;

//инициализация
extern void txtboxInit(void);

//включение/выключение отображения элемента
extern int16_t	txtboxOn(uint8_t dnum, uint8_t on);

//запись текста в элемент
extern int16_t	txtboxSettext(char * txt, uint8_t dnum);

//добавление текста в элемент
extern int16_t	txtboxAddtext(char * txt, uint8_t dnum);

//вывод элемента txtbox на экран
extern void	txtboxOut(uint8_t dnum);

//создание текстового элемента
extern int16_t	txtboxCreate(int16_t x,
			int16_t y,
			int16_t szx,
			int16_t	szy,
			uint8_t FR, 
			uint8_t FG, 
			uint8_t FB,
			uint8_t border
			);

//реализация вывода
extern void	txtboxRelease(void);

#endif

