//wsserver.c

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>    
#include <time.h>
#include <pthread.h>
#include <signal.h>
#include "bmpfunc.h"
#include "wsserver.h"
#include "wsfunc.h"
#include "wsconfig.h"
#include "bmp.h"
#include "workfunc.h"
#include "main.h"

//
int	shmCMD;
uint8_t	*addrCMD;
//int 	semCMD;
uint8_t *addrsemCMD;
//определение данных изображения
int	shmBMP;
uint8_t *addrsemBMP;
//int	semBMP;
uint8_t	*addrBMP;

struct sockaddr_in		svr_addr, cli_addr;
socklen_t sin_len 	= 	sizeof(cli_addr);
int				wsport;
int				listener;
pthread_mutex_t         	serverWSmutex;
pthread_t               	hlistenWSprocess;
uint8_t				work;
WSSERVER			wsserver;

int	startWSserver(void)
{
	int one = 1;
	listener = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (listener < 0) 
	{
		printf("not socket.\n");
		return -1;
	}
	//
	setsockopt(listener, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(int));
	svr_addr.sin_family = AF_INET;
	svr_addr.sin_addr.s_addr = INADDR_ANY;
	svr_addr.sin_port = htons(wsport);
	//
	if(bind(listener, (struct sockaddr *) &svr_addr, sizeof(svr_addr)) == -1) 
   	{
		close(listener);
		printf("error bind.\n");
		return -2;
   	}
	if(listen(listener, _maxWSsocket) == -1) 
	{
		close(listener);
		printf("error listen.\n");
		return -3;
	}
	//mutex create
        if(!(pthread_mutex_init(&serverWSmutex,NULL) == 0))
                return 4;
        //starting listen
	work	= 0xFF;
        pthread_create(&hlistenWSprocess,NULL,(void*) serverWSlisten,NULL);
        sleep(1);       //wait one secoond
	//
	return 0;
}

void	serverWSlisten(void)
{
	uint8_t		w;
	int		err;
	int		count;
	int 		csock;
	fd_set 		fdss;
        struct timeval 	tvs;
	w	= work;
	memset(&wsserver.midcl[0], 0, _maxWSsocket);
	wsserver.cntclient	= 0;
	while(w)
	{
		tvs.tv_sec	= _SOCKET_TIMEOUT_uS;
                tvs.tv_usec	= _SOCKET_TIMEOUT_uS;
                FD_ZERO(&fdss);
                FD_SET(listener,&fdss);
		//
		err = select(listener + 1,&fdss,&fdss,NULL,&tvs);
                if(err <= 0)
                {
			pthread_mutex_lock(&serverWSmutex);
			w	= work;
			pthread_mutex_unlock(&serverWSmutex);
			usleep(_listen_sleep);
                        continue;
                }
		csock = accept(listener,NULL,NULL);
		if(!(csock > 0))
                {
			pthread_mutex_lock(&serverWSmutex);
			w	= work;
			pthread_mutex_unlock(&serverWSmutex);
			usleep(_listen_sleep);
                        continue;
                }
		count	= 0;
		pthread_mutex_lock(&serverWSmutex);
                while(count < _maxWSsocket)
                {
                        if(wsserver.midcl[count] == 0)
                        {
				#if(_dbg_msg_server_listen > 0)
				printf("ServCoon client %i connecting...\n",count);
				#endif
                                wsserver.csock	 		= csock;
                                wsserver.idclient 		= count;
				wsserver.midcl[count]		= 0xFF;
				wsserver.cntclient++;
				//				
				pthread_attr_init(&wsserver.tattr[count]);
				pthread_attr_setdetachstate(&wsserver.tattr[count], PTHREAD_CREATE_DETACHED);
				pthread_create(&wsserver.pth[count], &wsserver.tattr[count],(void*) server_con, &wsserver);
				//
				break;
                        }
                        count++;
                }
                //
		w	= work;
                pthread_mutex_unlock(&serverWSmutex);
                usleep(_listen_sleep);
	}
	#if(_dbg_msg_server_listen > 0)
	printf("!!! - End listen\n");
	#endif
	pthread_exit(0); 
}

//чтение из сокета
__inline int wssRd(int nSocket, uint8_t *pBuffer, int size)
{
       //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = size;
        int     	iCount 	= 0;
	//u_int16_t	sz	= 0;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
	//u_int8_t	flag			= 0;
	//
        while(iStillToReceive > 0)
        {
                //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = _SOCKET_TIMEOUT_S;
        	ReceiveTimeout.tv_usec = _SOCKET_TIMEOUT_uS;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
		{
			if(iCount > 0)
			{
				#if(_dbg_msg_server_recv > 0)
				printf("Приём по сокету - таймаут, но данные приняты iCount=%i\n", iCount);
				#endif
				return iCount;
			}
			else
			{
				#if(_dbg_msg_server_recv > 0)
				printf("Приём по сокету - таймаут, и данные не приняты\n");
				#endif
				return -1;
			}
		}
		//произошла какая то ошибка
                if(iRC < 0)
		{
			#if(_dbg_msg_server_recv > 0)
			printf("Приём по сокету - какая то ошибка iRC=%i\n", iRC);
			#endif
                        return -2;
		}
                //прием нескольких байт
		iReceiveStatus = recv(nSocket, (u_int8_t*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
			pBuffer 	+= iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
                        iCount 		+= iReceiveStatus;
                }
		else if(iReceiveStatus == 0)
		{
			if(iCount > 0)
			{
				#if(_dbg_msg_server_recv > 0)
				printf("Приём по сокету - статус приёма iReceiveStatus=%i, но данные приняты iCount=%i\n", iReceiveStatus, iCount);
				#endif
				return iCount;
			}
			else
			{
				#if(_dbg_msg_server_recv > 0)
				printf("Приём по сокету - статус приёма iReceiveStatus=%i, и данные не приняты\n", iReceiveStatus);
				#endif
				return -1;
			}
		}
		else
		{
			#if(_dbg_msg_server_recv > 0)
			printf("Приём по сокету - статус приёма iReceiveStatus=%i, iCount=%i\n", iReceiveStatus, iCount);
			#endif
			return -2;
		}
        }
	return iCount;
}

//запись в сокет
__inline int wssWr(int nSocket, u_int8_t *pBuffer, int iMessageLength)
{
 	int		iCount		= 0;
        int 		iSC 		= 0;
        int		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
		//установка величины таймаута
		FD_ZERO(&fds);
        	FD_SET(nSocket, &fds);
        	SendTimeout.tv_sec  = _SOCKET_TIMEOUT_S;
        	SendTimeout.tv_usec = _SOCKET_TIMEOUT_uS;
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
		#if(_dbg_msg_server_send > 0)
		printf("Передача по сокету - select iSC=%i\n", iSC);
		#endif
                if(!iSC)
		{
			#if(_dbg_msg_server_send > 0)
			if(iCount > 0)
				printf("Передача по сокету - таймаут, но данные переданы iCount=%i\n", iCount);
			else
				printf("Передача по сокету - таймаут, и данные не переданы\n");
			#endif
                        return -1; //таймаут
		}
                if(iSC < 0)
		{
			#if(_dbg_msg_server_send > 0)
			printf("Передача по сокету - какая то ошибка iSC=%i\n", iSC);
			#endif
                        return -2; //ошибка
		}
		//отправить несколько байт
		iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
			#if(_dbg_msg_server_send > 0)
			printf("Передача по сокету - статус передачи iSendStatus = %i\n", iSendStatus);
			#endif
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
		else if(iSendStatus == 0)
		{
			#if(_dbg_msg_server_send > 0)
			if(iCount > 0)
				printf("Передача по сокету - статус передачи iSendStatus = %i, но данные переданы iCount=%i\n", iSendStatus, iCount);
			else
				printf("Передача по сокету - статус передачи iSendStatus = %i, и данные не переданы\n", iSendStatus);
			#endif
			return -1;
		}
		else
		{
			#if(_dbg_msg_server_send > 0)
			printf("Передача по сокету - статус передачи iSendStatus = %i\n", iSendStatus);
			#endif
			return -2;
		}
        }
	#if(_dbg_msg_server_send > 0)
	printf("Передача по сокету - передано %i байт\n", iCount);
	#endif
	return iCount;
}


//поток клиента
void server_con(WSSERVER * wss)
{
	WSSERVER	ws;
	WSDAT		wsdat;
	uint8_t		w;
	uint8_t		wsflag		= _cntWS_START;
	int		client_fd;
	int		res;
	int		sz64;
	//int		timelive	= _swtimelive;	
	pthread_mutex_lock(&serverWSmutex);
	w	= work;
	memcpy(&ws, wss, sizeof(WSSERVER));
	client_fd	= ws.csock;
	pthread_mutex_unlock(&serverWSmutex);
	#if(_dbg_msg_server_con > 0)
	printf("---client---\n");
	#endif
	while(w)
	{
		//если в работе, то передаём картинку
		if(wsflag == _cntWS_WORK)
		{
			pthread_mutex_lock(&MainMutex);
			sz64 = wsscreen(&wsdat.outbuffer[0], BmpDump, addrsemBMP);
			pthread_mutex_unlock(&MainMutex);
			#if(_dbg_msg_server_con > 0)
			printf("Поток клиента, передаём данные клиенту - флаг _cntWS_WORK\n");
			printf("sz64 = %i\n", sz64);
			#endif
			if(sz64 > 0)
			{
				res = wssWr(client_fd, &wsdat.outbuffer[0], sz64);
				#if(_dbg_msg_server_con > 0)
				printf("send src: res = %i\n", res);
				#endif
			}
		}
		else 
			memset(&wsdat.inbuffer[0], 0, _BUFSIZEin);
		res = wssRd(client_fd, &wsdat.inbuffer[0], _BUFSIZEin);
		switch(res)
		{
			case -1: //таймаут по приёму - делаем PING
				if(wsdat.flagping)	//флаг PING пока не активен
				{
					memset(&wsdat.inbuffer[0], 0, _BUFSIZEin);
					wsdat.inbuffer[0]	= WS_OPCODE_PING | FIN1;
					wsdat.inbuffer[1] = sprintf((char*)(&wsdat.inbuffer[0] + 2), "Hello");
					#if(_dbg_msg_server_con > 0)
					printf("Wr(ping) size=%i:%s\n", 7, &wsdat.inbuffer[0]);
					#endif
					res = wssWr(client_fd, &wsdat.inbuffer[0], 7);
					if(res < 0)	//ошибка передачи - клиент отвалился
						goto mexit;
				}
				break;
			case -2:	//ошибка сокета - клиент отвалился
				goto mexit;
			default:	//данные приняты
				switch(wsflag) //циклограмма работы websocket
				{
					case _cntWS_START:	//начало соединения
						#if(_dbg_msg_server_con > 0)
						printf("Поток клиента, данные от клиента приняты - начало соединения флаг _cntWS_START\n");
						#endif
						res = wsin(&wsdat);
						res = wsout(&wsdat);
						res = wssWr(client_fd, &wsdat.resp[0], wsdat.szresp);
						if(res < 0)	//не удалось ответить - клиент отвалился
							goto mexit;
						wsdat.flagping	= 0xFF;
						wsflag	= _cntWS_PING;
						break;
					case _cntWS_PING:	//
						#if(addrCMD_dbg_msg_server_con > 0)
						printf("Поток клиента, данные от клиента приняты - флаг _cntWS_PING\n");
						#endif
						//res = wsin(&wsdat);
						res = wsfunc(&wsdat);
						switch(res)
						{
							case -1:
								goto mexit;
							case -2:
								wsdat.flagping	= 0xFF;
								wsflag	= _cntWS_PONG;
								break;
							default:
								break;
						}
						break;
					case _cntWS_PONG:	//
						#if(_dbg_msg_server_con > 0)
						printf("Поток клиента, данные от клиента приняты - флаг _cntWS_PONG\n");
						#endif
						//res = wsin(&wsdat);
						res = wsfunc(&wsdat);
						switch(res)
						{
							case -1:
								goto mexit;
							case -2:
								wsdat.flagping	= 0;
								wsflag	= _cntWS_WORK;
								flagNew = 0xFF;
								break;
							default:
								wsdat.flagping	= 0xFF;
								break;
						}
						break;
					default:
						#if(_dbg_msg_server_con > 0)
						printf("Поток клиента, данные от клиента приняты - флаг _cntWS_WORK\n");
						#endif
						res = wsin(&wsdat);
						//printf("test\n");
						res = wsfunc(&wsdat);
						switch(res)
						{
							case -1:
								goto mexit;
							default:
								//wmutlock(addrsemCMD);
								pthread_mutex_lock(&MainMutex);
								wsworkfunc((char*)(&rdbuf[0]));
								pthread_mutex_unlock(&MainMutex);
								//wmutunlock(addrsemCMD);
								break;
						}
						break;
				}
				break;
		}
		pthread_mutex_lock(&serverWSmutex);
		w	= work;
		pthread_mutex_unlock(&serverWSmutex);
		usleep(_swclient_sleep);
	}
mexit:	shutdown(client_fd, SHUT_RDWR);
	pthread_mutex_lock(&serverWSmutex);
	wss->midcl[ws.idclient] = 0;
	wss->cntclient--;
	pthread_mutex_unlock(&serverWSmutex);
	#if(_dbg_msg_server_con > 0)
	printf("== Close Client ==\n");
	#endif
	pthread_exit(0); 
}
